/*Polyfill
Running the following code before any other code will create trim() if it's not natively available.
https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/Trim
use by : http://jvitela.github.io/mustache-wax/
*/
if (!String.prototype.trim) {
  String.prototype.trim = function () {
    return this.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '');
  };
}

var viwutils = function() {
    var toto = "tata";
   
    return {
        
        /**
		 * Set/Overwrite a cookie value
		 *
		 * @param name
		 * @param value
		 * @param days      OPTIONAL Days till this cookie will stay valid. Default is current session
		 * @param path      OPTIONAL domain root will be used by default
		 */
		setcookie: function(name, value, days, path) {
			if (days) {
				var date = new Date();
					date.setTime(date.getTime()+(days*24*60*60*1000));
				var expires = "; expires="+date.toGMTString();
			} else var expires = "";

			var dir = path || '/';
			document.cookie = name+"="+value+expires+"; path="+dir;
		},
		
		/**
		 * Retrieve a cookie value
		 *
		 * @param name
		 * @return String|null
		 */
		getcookie: function(name) {
			var nameEQ = name + "=";
			var ca = document.cookie.split(';');
			for(var i=0;i < ca.length;i++) {
				var c = ca[i];
				while (c.charAt(0)==' ') c = c.substring(1,c.length);
				if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
			}
			return null;
		},
		
		/**
		 * Remove a cookie
		 *
		 * @param name
		 */
		deletecookie: function(name) {
			this.set(name,"",-1);
		},
		
		
		/**
		 * Get unique ID
		 *
		 * @param none
		 * @return String
		 */
		getuniqueID: function() {
            return (Date.now().toString(36) + Math.random().toString(36).substr(2, 5)).toUpperCase();
        },
		
		/*--------------------------*/
		/* http://locutus.io/php/ */
		/*--------------------------*/
		//  Encode une chaîne en URL, selon la RFC 3986
		rawurlencode: function(str) {
            str = (str + '')
			return encodeURIComponent(str)
			.replace(/!/g, '%21')
			.replace(/'/g, '%27')
			.replace(/\(/g, '%28')
			.replace(/\)/g, '%29')
			.replace(/\*/g, '%2A')
        },
		// retourne la chaîne str dont les séquences de caractères %xy, avec xy deux valeurs hexadécimales, auront été remplacées par le caractère ASCII correspondant.
		rawurldecode: function(str) {
            return decodeURIComponent((str + '')
			.replace(/%(?![\da-f]{2})/gi, function () {
			  // PHP tolerates poorly formed escape sequences
			  return '%25'
			}))
        },
		
		strip_tags: function(input, allowed) { 
			
			//   example 1: strip_tags('<p>Kevin</p> <br /><b>van</b> <i>Zonneveld</i>', '<i><b>')
			//   returns 1: 'Kevin <b>van</b> <i>Zonneveld</i>'
			//   example 2: strip_tags('<p>Kevin <img src="someimage.png" onmouseover="someFunction()">van <i>Zonneveld</i></p>', '<p>')
			//   returns 2: '<p>Kevin van Zonneveld</p>'
			//   example 3: strip_tags("<a href='http://kvz.io'>Kevin van Zonneveld</a>", "<a>")
			//   returns 3: "<a href='http://kvz.io'>Kevin van Zonneveld</a>"
			//   example 4: strip_tags('1 < 5 5 > 1')
			//   returns 4: '1 < 5 5 > 1'
			//   example 5: strip_tags('1 <br/> 1')
			//   returns 5: '1  1'
			//   example 6: strip_tags('1 <br/> 1', '<br>')
			//   returns 6: '1 <br/> 1'
			//   example 7: strip_tags('1 <br/> 1', '<br><br/>')
			//   returns 7: '1 <br/> 1'
		
		  allowed = (((allowed || '') + '').toLowerCase().match(/<[a-z][a-z0-9]*>/g) || []).join('')

		  var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi
		  var commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi

		  return input.replace(commentsAndPhpTags, '').replace(tags, function ($0, $1) {
			return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : ''
		  })
		},
		
		stripslashes: function(str) { 
		  return (str + '')
			.replace(/\\(.?)/g, function (s, n1) {
			  switch (n1) {
				case '\\':
				  return '\\'
				case '0':
				  return '\u0000'
				case '':
				  return ''
				default:
				  return n1
			  }
			})
		},
		
		str_replace: function (search, replace, subject, countObj) { // eslint-disable-line camelcase
		  

		  var i = 0
		  var j = 0
		  var temp = ''
		  var repl = ''
		  var sl = 0
		  var fl = 0
		  var f = [].concat(search)
		  var r = [].concat(replace)
		  var s = subject
		  var ra = Object.prototype.toString.call(r) === '[object Array]'
		  var sa = Object.prototype.toString.call(s) === '[object Array]'
		  s = [].concat(s)

		  var $global = (typeof window !== 'undefined' ? window : global)
		  $global.$locutus = $global.$locutus || {}
		  var $locutus = $global.$locutus
		  $locutus.php = $locutus.php || {}

		  if (typeof (search) === 'object' && typeof (replace) === 'string') {
			temp = replace
			replace = []
			for (i = 0; i < search.length; i += 1) {
			  replace[i] = temp
			}
			temp = ''
			r = [].concat(replace)
			ra = Object.prototype.toString.call(r) === '[object Array]'
		  }

		  if (typeof countObj !== 'undefined') {
			countObj.value = 0
		  }

		  for (i = 0, sl = s.length; i < sl; i++) {
			if (s[i] === '') {
			  continue
			}
			for (j = 0, fl = f.length; j < fl; j++) {
			  temp = s[i] + ''
			  repl = ra ? (r[j] !== undefined ? r[j] : '') : r[0]
			  s[i] = (temp).split(f[j]).join(repl)
			  if (typeof countObj !== 'undefined') {
				countObj.value += ((temp.split(f[j])).length - 1)
			  }
			}
		  }
		  return sa ? s : s[0]
		},
		
		explode: function(delimiter, string, limit) { 
			//  discuss at: http://locutus.io/php/explode/
			// original by: Kevin van Zonneveld (http://kvz.io)
			//   example 1: explode(' ', 'Kevin van Zonneveld')
			//   returns 1: [ 'Kevin', 'van', 'Zonneveld' ]

			if (arguments.length < 2 ||
				typeof delimiter === 'undefined' ||
				typeof string === 'undefined') {
				return null
			 }
			if (delimiter === '' ||
				delimiter === false ||
				delimiter === null) {
				return false
			}
			if (typeof delimiter === 'function' ||
				typeof delimiter === 'object' ||
				typeof string === 'function' ||
				typeof string === 'object') {
				return {
				  0: ''
				}
			}
			if (delimiter === true) {
				delimiter = '1'
			}

			// Here we go...
			delimiter += ''
			string += ''

			var s = string.split(delimiter)

			if (typeof limit === 'undefined') return s

			// Support for limit
			if (limit === 0) limit = 1

			// Positive limit
			if (limit > 0) {
				if (limit >= s.length) {
				  return s
				}
				return s
				  .slice(0, limit - 1)
				  .concat([s.slice(limit - 1)
					.join(delimiter)
				  ])
			}
		
			// Negative limit
			if (-limit >= s.length) {
				return []
			}

			s.splice(s.length + limit)
			return s
		},
		
		urlencode: function(str) { 
		  str = (str + '')
		  // Tilde should be allowed unescaped in future versions of PHP (as reflected below),
		  // but if you want to reflect current
		  // PHP behavior, you would need to add ".replace(/~/g, '%7E');" to the following.
		  return encodeURIComponent(str)
			.replace(/!/g, '%21')
			.replace(/'/g, '%27')
			.replace(/\(/g, '%28')
			.replace(/\)/g, '%29')
			.replace(/\*/g, '%2A')
			.replace(/%20/g, '+')
		},
		
		intval: function(mixedVar, base) { 
			var tmp
			var type = typeof mixedVar
			if (type === 'boolean') {
				return +mixedVar
			} else if (type === 'string') {
				tmp = parseInt(mixedVar, base || 10)
				return (isNaN(tmp) || !isFinite(tmp)) ? 0 : tmp
			} else if (type === 'number' && isFinite(mixedVar)) {
				return mixedVar | 0
			} else {
				return 0
			}
		},
		
		/*--------------------------*/
		/* end of locutus
		/*--------------------------*/
		replaceasctoquote: function(s) { 
			s = s.replace(/\&#39;/g, '\'' );
			s = s.replace(/\&#34;/g, '"' );
			return s;
		},
		// http://www.madirish.net/17
		replacequotetoasc: function(s) { 
			s = s.replace(/\'/g, "&#39;");
			s = s.replace(/\"/g, "&#34;");
			return s;
		},
		
		replaceallquotesinform: function(idform) { 
			var els = document.getElementById(idform).elements;
			var n = els.length;
			for (var i=0; i<n; i++)  {
			  // replace all the single, double quotes: to &#39; or &#34;
				var curElement = els[i];
				curElement.value = viwutils.replacequotetoasc(curElement.value);
			}
			return true;
		},
		
		//http://jsfiddle.net/W33YR/3/
		visibleY: function(el){
			var top = el.getBoundingClientRect().top, rect, el = el.parentNode;
			do {
				rect = el.getBoundingClientRect();
				if (top <= rect.bottom === false)
					return false;
				el = el.parentNode;
			} while (el != document.body);
			// Check its within the document viewport
			return top <= document.documentElement.clientHeight;
		},
		
		// for segmenter background effect 
		// Helper vars and functions.
		extend: function( a, b ) {
			for( var key in b ) { 
				if( b.hasOwnProperty( key ) ) {
					a[key] = b[key];
				}
			}
			return a;
		},
		
		// From https://davidwalsh.name/javascript-debounce-function.
		debounce: function(func, wait, immediate) {
			var timeout;
			return function() {
				var context = this, args = arguments;
				var later = function() {
					timeout = null;
					if (!immediate) func.apply(context, args);
				};
				var callNow = immediate && !timeout;
				clearTimeout(timeout);
				timeout = setTimeout(later, wait);
				if (callNow) func.apply(context, args);
			};
		},
	
		// Creates a sorted array of random numbers between minVal and maxVal with a length = size.
		createRandIntOrderedArray: function(minVal, maxVal, size) {
			var arr = [];
			for(var i=0; i<size; ++i) {
				arr.push(anime.random(minVal, maxVal));
			}
			arr.sort(function(a, b){ return a-b });
			return arr;
		},
		
		// Checks if an object is empty.
		isObjEmpty: function (obj) {
			return Object.getOwnPropertyNames(obj).length > 0;
		},
	
		// Concatenate JS objs.
		// From http://stackoverflow.com/a/2454315.
		collect: function() {
			var ret = {};
			var len = arguments.length;
			for (var i=0; i<len; i++) {
				for (var p in arguments[i]) {
					if (arguments[i].hasOwnProperty(p)) {
						ret[p] = arguments[i][p];
					}
				}
			}
			return ret;
		},
		
		// Check if clip-path is supported. From http://stackoverflow.com/a/30041538.
		areClipPathShapesSupported: function() {
			var base = 'clipPath',
				prefixes = [ 'webkit', 'moz', 'ms', 'o' ],
				properties = [ base ],
				testElement = document.createElement( 'testelement' ),
				attribute = 'polygon(50% 0%, 0% 100%, 100% 100%)';

			// Push the prefixed properties into the array of properties.
			for ( var i = 0, l = prefixes.length; i < l; i++ ) {
				var prefixedProperty = prefixes[i] + base.charAt( 0 ).toUpperCase() + base.slice( 1 ); // remember to capitalize!
				properties.push( prefixedProperty );
			}

			// Interate over the properties and see if they pass two tests.
			for ( var i = 0, l = properties.length; i < l; i++ ) {
				var property = properties[i];

				// First, they need to even support clip-path (IE <= 11 does not)...
				if ( testElement.style[property] === '' ) {

					// Second, we need to see what happens when we try to create a CSS shape...
					testElement.style[property] = attribute;
					if ( testElement.style[property] !== '' ) {
						return true;
					}
				}
			}
			return false;
		},
		
		// mustache render
		// <script id="template" type="x-tmpl-mustache">
		// Hello {{ name }}!
		// </script>
		// <div id="target">Loading...</div>
		// viwutils.mustacheRender('#template', {name: "Luke"}, '#target')
		// http://stackoverflow.com/questions/13097316/do-a-simple-calculation-in-a-mustache-js-template 
		// http://jvitela.github.io/mustache-wax/
		mustacheRender: function(id_tpl, o, target) {
			var template = $(id_tpl).html();
			Mustache.parse(template);   // optional, speeds up future uses
			var rendered = Mustache.render(template, o);
			target.html(rendered);
		},
		
		cloneObject: function(o) {
			if (typeof o != "object" || o === null) return o;
			var o2 = [];
			for (var v in o) o2[v] = viwutils.cloneObject(o[v]);
			return o2;
		},
		
		// parse shotocode content to array
		// [viw_acc title="toto" icon_icon="" icon_align="icon_right" ]tata[/viw_acc]
		// object ["0"] content:"tata" icon_align:"icon_right" title:"toto"
		parseShorcodeWidget: function(mycontent, loop_limit) {
			mycontent = viwutils.replaceasctoquote(mycontent);
			mycontent = mycontent +'[last_viw_limit v=1]'; 
			var loop_exit=0;
			var awidgets = new Array();
			var countelement=0;
			do{
				loop_exit++;
				var element_shortcode=mycontent.substring(mycontent.indexOf("[")+1,Math.min(mycontent.indexOf(" ",mycontent.indexOf("[")), mycontent.indexOf("]",mycontent.indexOf("["))));
				if(element_shortcode!==''){
					current_element = wp.shortcode.next( element_shortcode, mycontent );
					if(typeof current_element !== 'undefined'){
						element_name = current_element.shortcode.tag;
					}
					
					if(element_name!=='last_viw_limit'){
						var shortcode = current_element.content;
						var tmpwidgetdata = new Object();				
						$.each(current_element.shortcode.attrs.named, function(attribute, value) {
							tmpwidgetdata[attribute]=value;
						});
														
						var element_content = current_element.shortcode.content;
						if(element_content==undefined){
							element_content='';
						}
						
						tmpwidgetdata["content"]= viwutils.rawurldecode(element_content);
						countelement = countelement + 1;
						awidgets.push(tmpwidgetdata);			
					}				
					mycontent = mycontent.replace(current_element.content, '').trim();
				}
				
				
			}while(mycontent.indexOf("[")>=0 && loop_exit<loop_limit);
			
			return awidgets;
		},
		
		splitUri: function() {
			/*
			var splitRegExp = new RegExp(
				'^' +
					'(?:' +
					'([^:/?#.]+)' +                         // scheme - ignore special characters
															// used by other URL parts such as :,
															// ?, /, #, and .
					':)?' +
					'(?://' +
					'(?:([^/?#]*)@)?' +                     // userInfo
					'([\\w\\d\\-\\u0100-\\uffff.%]*)' +     // domain - restrict to letters,
															// digits, dashes, dots, percent
															// escapes, and unicode characters.
					'(?::([0-9]+))?' +                      // port
					')?' +
					'([^?#]+)?' +                           // path
					'(?:\\?([^#]*))?' +                     // query
					'(?:#(.*))?' +                          // fragment
					'$');

			return function (uri) {
				var split;
				split = uri.match(splitRegExp);
				return {
					'scheme':split[1],
					'user_info':split[2],
					'domain':split[3],
					'port':split[4],
					'path':split[5],
					'query_data': split[6],
					'fragment':split[7]
				}
			};
			*/
		},

    }
}();



/*
var splitUri = (function() {
    var splitRegExp = new RegExp(
        '^' +
            '(?:' +
            '([^:/?#.]+)' +                         // scheme - ignore special characters
                                                    // used by other URL parts such as :,
                                                    // ?, /, #, and .
            ':)?' +
            '(?://' +
            '(?:([^/?#]*)@)?' +                     // userInfo
            '([\\w\\d\\-\\u0100-\\uffff.%]*)' +     // domain - restrict to letters,
                                                    // digits, dashes, dots, percent
                                                    // escapes, and unicode characters.
            '(?::([0-9]+))?' +                      // port
            ')?' +
            '([^?#]+)?' +                           // path
            '(?:\\?([^#]*))?' +                     // query
            '(?:#(.*))?' +                          // fragment
            '$');

    return function (uri) {
        var split;
        split = uri.match(splitRegExp);
        return {
            'scheme':split[1],
            'user_info':split[2],
            'domain':split[3],
            'port':split[4],
            'path':split[5],
            'query_data': split[6],
            'fragment':split[7]
        }
    };

	})();

*/

(function($) {
	$.fn.getHiddenDimensions = function(need) {
		var $item = this;
		var props = {
			position: "absolute",
			visibility: "hidden",
			display: "block"
		};
		var dim = {
			"w": 0,
			"h": 0
		};
		var $hiddenParents = $item.parents().andSelf().not(":visible");
		var oldProps = [];
		$hiddenParents.each(function() {
			var old = {};
			for (var name in props) {
				old[name] = this.style[name];
				this.style[name] = props[name];
			}
			oldProps.push(old);
		});
		switch (need) {
			case "outer":
				dim.outerWidth = $item.outerWidth();
				dim.outerHeight = $item.outerHeight();
				break;
			case "whouter":
				dim.width = $item.width();
				dim.height = $item.height();
				dim.outerWidth = $item.outerWidth();
				dim.outerHeight = $item.outerHeight();
				break;
			case "xyouter":
				var tmp = $item.offset();
				dim.x = tmp.left;
				dim.y = tmp.top;
				dim.outerWidth = $item.outerWidth();
				dim.outerHeight = $item.outerHeight();
				break;
			default:
				dim.width = $item.width();
				dim.height = $item.height();
				break;
		}
		$hiddenParents.each(function(i) {
			var old = oldProps[i];
			for (var name in props) {
				this.style[name] = old[name];
			}
		});
		return dim;
	};
	$.fn.removeClassRegEx = function(regex) {
		var classes = $(this).attr('class');
		if (!classes || !regex) return false;
		var classArray = [];
		classes = classes.split(' ');
		for (var i = 0, len = classes.length; i < len; i++)
			if (!classes[i].match(regex)) classArray.push(classes[i]);
		$(this).attr('class', classArray.join(' '));
		return $(this);
	};
	$.fn.hasClassRegEx = function(regex) {
		var classes = $(this).attr('class');
		if (!classes || !regex) return false;
		classes = classes.split(' ');
		for (var i = 0, len = classes.length; i < len; i++)
			if (classes[i].match(regex)) return true;
		return false;
	};
}(jQuery));

// usage : 
// <body class="lng40" >
// $("body").removeClassRegEx(/^lng/).addClass("lng" + config.get("application.language.id"));








