<?php
if(!defined('PLX_ROOT')) exit;
if(!empty($_POST)) {
	# Control du token du formulaire
	plxToken::validateFormToken($_POST);

	$plxPlugin->setParam("viwfontdefault", $_POST["viwfontdefault"], 'string');
	$plxPlugin->setParam("viwcontainerwidth", $_POST["viwcontainerwidth"], 'numeric');
	$plxPlugin->setParam("viwcsslargedevice", $_POST["viwcsslargedevice"], 'numeric');
	$plxPlugin->setParam("viwcssmediumdevice", $_POST["viwcssmediumdevice"], 'numeric');

	$option = array("viwpost", "viwpage","viwcategorie");
	foreach ($option as $k) {
			$value = (isset($_POST[$k])) ? 1 : 0;
			$plxPlugin->setParam($k, $value, 'numeric');
	}

	$plxPlugin->saveParams();
	include __DIR__ . '/lib/class.spxvisualwizard.ressource.php';
	include __DIR__ . '/lib/class.spxvisualwizard.utils.php';
	spxvisualwizardRessource::init(PLX_ROOT."data/visualwizard", $plxPlugin);
}

$viwfontdefault = $plxPlugin->getParam('viwfontdefault');
$viwcontainerwidth = $plxPlugin->getParam('viwcontainerwidth');
$viwcsslargedevice = $plxPlugin->getParam('viwcsslargedevice');
$viwcssmediumdevice = $plxPlugin->getParam('viwcssmediumdevice');

$viwpost = $plxPlugin->getParam('viwpost');
$viwpostchecked = "";
if ($viwpost==1) $viwpostchecked='checked="checked"';

$viwpage = $plxPlugin->getParam('viwpage');
$viwpagechecked = "";
if ($viwpage==1) $viwpagechecked='checked="checked"';

$viwcategorie= $plxPlugin->getParam('viwcategorie');
$viwcategoriechecked = "";
if ($viwcategorie==1) $viwcategoriechecked='checked="checked"';

?>



<style>
.viw-description {
  font-style: italic;
}
.viw-heading{
margin : 0 0 0 0;

}
.viw-spacer{
	margin-top:40px;
}

</style>

</style>

<form action="parametres_plugin.php?p=spxvisualwizard" method="post" id="form_spxvisualwizard" >
	<fieldset>
		<div class="grid">
			<div class="col sml-12">
			<hr>
			<h4 class="--heading-small viw-heading" ><?php $plxPlugin->lang('L_GENERAL') ?></h4>

			</div>
		</div>
		<div class="grid">
			<div class="col sml-12 med-3 label-centered">
				<label><strong><?php $plxPlugin->lang('L_TYPE_OF_CONTENT') ?></strong></label>
			</div>
			<div class="col sml-12 med-9">
				<label>
				<input type="checkbox" name="viwpost" value="1" <?php echo ($viwpostchecked) ?>>
				<?php $plxPlugin->lang('L_ARTICLES') ?></label>
				<br>
				<label>
				<input type="checkbox" name="viwpage" value="1" <?php echo ($viwpagechecked) ?>>
				<?php $plxPlugin->lang('L_PAGES') ?></label>
				<br>
				<label>
				<input type="checkbox" name="viwcategorie" value="1" <?php echo ($viwcategoriechecked) ?>>
				<?php $plxPlugin->lang('L_CATEGORIE') ?></label>

			</div>
		</div>
		<div class="grid">
			<div class="col sml-12">
			<hr>
			<h4 class="--heading-small viw-heading" ><?php $plxPlugin->lang('L_STYLE') ?></h4>


			</div>
		</div>
		<div class="grid">
			<div class="col sml-12 med-3 label-centered">
				<label><strong><?php $plxPlugin->lang('L_FONT_BY_DEFAULT') ?></strong></label>
			</div>
			<div class="col sml-12 med-9">
				<input name="viwfontdefault" type="text" placeholder="Sans-serif" value="<?php echo ($viwfontdefault); ?>" >
				<p class="viw-description"><?php $plxPlugin->lang('L_FONT_BY_DEFAULT_DESC') ?></p>
			</div>
		</div>
		<div class="grid">
			<div class="col sml-12 med-3 label-centered">
				<label><strong><?php $plxPlugin->lang('L_WIDTH_OF_CONTENT') ?></strong></label>
			</div>
			<div class="col sml-12 med-9">
				<input name="viwcontainerwidth" type="text" placeholder="1280" value="<?php echo ($viwcontainerwidth); ?>" > px
				<p class="viw-description"><?php $plxPlugin->lang('L_DEFINE_WIDTH_OF_CONTENT') ?></p>
			</div>
		</div>

		<div class="grid">
			<div class="col sml-12 med-3 label-centered">
				<label><strong><?php $plxPlugin->lang('L_RESPONSIVE_QUERIES') ?></strong></label>
			</div>
			<div class="col sml-12 med-9">
				<input name="viwcsslargedevice" type="text" placeholder="1024" value="<?php echo ($viwcsslargedevice); ?>" > px
				<p class="viw-description"><?php $plxPlugin->lang('L_LARGE_DEVICE') ?></p>
			</div>
		</div>

		<div class="grid">
			<div class="col sml-12 med-3 label-centered">
				<label><strong><?php $plxPlugin->lang('L_RESPONSIVE_QUERIES') ?></strong></label>
			</div>
			<div class="col sml-12 med-9">
				<input name="viwcssmediumdevice" type="text" placeholder="768" value="<?php echo ($viwcssmediumdevice); ?>" > px
				<p class="viw-description"><?php $plxPlugin->lang('L_MEDIUM_DEVICE') ?></p>
			</div>
		</div>

		<?php echo plxToken::getTokenPostMethod() ?>

		<div class="grid">
			<div class="col sml-12 med-9 med-offset-3">
				<input type="submit" value="<?php $plxPlugin->lang('L_SAVE') ?>">
			</div>
		</div>
	</fieldset>
</form>