<?php

/**
 * Classe spxvisualwizardRessource rassemblant les fonctions utiles au wizard pour la gestion des fichiers externes
 *
 * @package SPX
 * @author	je-evrard
 **/
class spxvisualwizardRessource {

	# dossier local pour les ressources
	public static $ressource_dir = '';
	
	# init from config.php at this step
	public  static function init($ressource_dir, $plxPlugin) {
		self::set_ressource_dir($ressource_dir);
		
		//self::build_font_google();
		self::build_css($plxPlugin->getParam('viwcsslargedevice'), $plxPlugin->getParam('viwcssmediumdevice'));
	}
	
	/***************************************************/
	/* PRIVATE */
	/***************************************************/
	private  static function set_ressource_dir($s) {
		self::check_folder($s);
		self::check_folder($s.'/templates');
		self::check_folder($s.'/sections');
		self::check_folder($s.'/widgets');
		self::check_folder($s.'/configuration');
		self::check_folder($s.'/fonts');
		self::check_folder($s.'/css');
		self::$ressource_dir = $s.'/';
	}
	
	private  static function check_folder($s) {
		if(!is_dir($s)) {
			mkdir($s,0755,true);
		}
	}
	/***************************************************/
	/* RESPONSIVE CSS */
	/***************************************************/
	private  static function build_css($w1, $w2) {
		$dir = self::$ressource_dir."/css/";
		$file_frontend = PLX_PLUGINS."spxvisualwizard/widgets/vwiconfig.css";
		$content = file_get_contents($file_frontend);
		$content = str_replace("@media (min-width: 768px) and (max-width: 1023px)", "@media (min-width: ".$w2."px) and (max-width: ".($w1-1)."px)", $content);
		
		$content = str_replace("@media (min-width: 1024px)", "@media (min-width: ".$w1."px)", $content);
		$content = str_replace("@media (min-width: 768px)", "@media (min-width: ".$w2."px)", $content);
		$content = str_replace("@media (max-width: 767px)", "@media (max-width: ".($w2-1)."px)", $content);
		
		
		
		
		$ret_f = spxvisualwizardUtils::write(trim($content), $dir."vwiconfig.css");
		/* 
		1- load responsive css like a string 
			$file_frontend = PLX_ROOT.PLX_CONFIG_PATH.'plugins/'.basename($plugin).'.site.css';
		2- replace rezsponsive val by config value
			$content = file_get_contents($file_frontend);
			http://mekalab.fr/taille-des-ecrans-responsive-design-et-point-de-rupture/
			entre med et large @media (min-width: 1024px)
			entre small et med @media (min-width: 768px)
			$content = str_replace("@media (min-width: 1024px)", "@media (min-width: ".$val."px)", $content);
			$content = str_replace("@media (min-width: 768px)", "@media (min-width: ".$val."px)", $content);
		3- record string in css folder
			$ret_f = plxUtils::write(trim($_POST['frontend']), $file_frontend);
		
		*/
	}
	/***************************************************/
	/* GOOGLE FONTS */
	/***************************************************/
	private  static function build_font_google() {
		$dir = self::$ressource_dir."/fonts/";
		$apikey = 'AIzaSyAYqNocytJ-5GIBZV9p4dLIbMPkhggvHyo';
		$cachefile = $dir.'fonts.json';
		$cachetime = 60 * 60;
		// Serve from the cache if it is younger than $cachetime
		if (file_exists($cachefile) && time() - $cachetime < filemtime($cachefile)) {
			include($cachefile);
			exit;
		}
		$content = file_get_contents('https://www.googleapis.com/webfonts/v1/webfonts?key=' . $apikey);
		file_put_contents($cachefile,$content);
	}
	
	
	
	
}
?>