<?php

/**
 * Classe plxUtils rassemblant les fonctions utiles à PluXml
 *
 * @package SPX
 * @author	Je-evrard
 **/
class spxshortcodesSelector {

	public static $shortcodes = array();
	/**
	 * Méthode qui converti les liens relatifs en liens absolus
	 *
	 * @param	base		url du site qui sera rajoutée devant les liens relatifs
	 * @param	html		chaine de caractères à convertir
	 * @param	dirs		configuration des dossiers issues du fichier parametres.xml
	 * @return	string		chaine de caractères modifiée
	 * @author	Stephane F., Amaury Graillat
	 **/
	public static function buildShortcodelist($base, $html) {

		

	}
	
	function get_shortcodes( $shortcode = false ) {
		if ( $shortcode ){
			return self::$shortcodes[$shortcode];
		}
		else{
			ksort(self::$shortcodes);
			return self::$shortcodes;
		}
	}
	
	public static function displayShortcodelist($editor='dnd') {
		$s='';
		foreach ( self::$shortcodes as $name => $shortcode ) {
			if ( (!isset($shortcode['hidden']) || (isset($shortcode['hidden']) && $shortcode['hidden'] != '1' )) && !($editor=='dnd' && (isset($shortcode['hide_in_dnd']) && $shortcode['hide_in_dnd']))){
				$child_name = (!empty($shortcode['child'])) ? ' &rarr; ['.$shortcode['child'].']' : '';
				$description = (isset($shortcode['description'])) ? $shortcode['description'] : 'Shortcode';
				$s.= '<li class="dnd_select_shortcode" data-shortcode="'.$name.'"><span class="item-title">' . $description . '</span><span class="item-info">[' . $name . ']'.$child_name.'</span></li>';
			}
		}

	}
	
	public static function third_party() {
		$return = array();
		foreach(self::$shortcodes as $shortcode => $att){
			if(isset($att['third_party']) && $att['third_party'] == 1){
				$return[] = $shortcode;
			}
		}
		$return = implode(',', $return);
		return $return;
	}

	public static function the_content_filter($content) {
		foreach ( self::$shortcodes as $name => $shortcode ) {
			$shortcode_list[] = $name;
			$shortcode_list[] = str_replace('_dd', '_DD', $name);
		}
		$block = join("|", $shortcode_list);
		$rep = preg_replace("/(<p>)?\[($block)(\s[^\]]+)?\](<\/p>|<br \/>)?/","[$2$3]",$content);
		$rep = preg_replace("/(<p>)?\[\/($block)](<\/p>|<br \/>)?/","[/$2]",$rep);
		return $rep;
	}

	public static function shortcode_names() {
		$return = array();
		foreach(self::$shortcodes as $shortcode => $att){
			$return[$shortcode] = (isset($att['description'])) ? $att['description'] : '';
		}
		return $return;
	}

	public static function extract_attributes ($shortcode) {
		foreach(self::$shortcodes[$shortcode]['attributes'] as $att => $val){
			$defaults[$att] = (isset($val['default'])) ? $val['default'] : '';
		}
		return $defaults;
	}

	public static function name_to_id($name){
		$class = strtolower(str_replace(array(' ',',','.','"',"'",'/',"\\",'+','=',')','(','*','&','^','%','$','#','@','!','~','`','<','>','?','[',']','{','}','|',':',),'',$name));
		return $class;
	}
	
	/**
	 * Méthode qui génère le fichier css admin.css ou site.css
	 *
	 * @param	type		type du fichier (admin|site)
	 * @return	boolean		vrai si cache généré
	 * @author	Stephane F
	 **/
	public static function cssCache($type) {
		/*
		$cache = '';
		foreach($this->aPlugins as $plugName => $plugInstance) {
			$filename = PLX_ROOT.PLX_CONFIG_PATH.'plugins/'.$plugName.'.'.$type.'.css';
			if(is_file($filename)) {
				$cache .= trim(file_get_contents($filename));
			} else {
				$filename = PLX_PLUGINS.$plugName.'/css/'.$type.'.css';
				if(is_file($filename)) {
					$cache .= trim(file_get_contents($filename));
				}
			}
		}
		if(is_file(PLX_PLUGINS.$type.'.css'))
			unlink(PLX_PLUGINS.$type.'.css');
		if($cache!='') {
			return plxUtils::write(plxUtils::minify($cache), PLX_PLUGINS.$type.'.css');
		}
		return true;
		*/
	}
}
?>