<?php

/**
 * Classe plxUtils rassemblant les fonctions utiles à PluXml
 *
 * @package PLX
 * @author	Florent MONTHEL et Stephane F
 **/
class spxvisualwizardUtils {

	/**
	 * Méthode qui minifie un buffer
	 *
	 * @param	string		chaine de caractères à minifier
	 * @return	string		chaine de caractères minifiée
	 * @author	Frédéric Kaplon
	 **/
	public static function minify($buffer) {
		/* Supprime les commentaires */
		$buffer = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $buffer);
		/* Supprime les tabs, espaces, saut de ligne, etc. */
		$buffer = str_replace(array("\r\n", "\r", "\n", "\t", '  ', '    ', '    '), '', $buffer);
		return $buffer;
	}
	 /**
     * Given a HEX string returns a RGB array equivalent.
     * @param string $color
     * @return array RGB associative array
     */
    public static function hexToRgb( $color ){

        // Sanity check
        $color = self::_checkHex($color);

        // Convert HEX to DEC
        $R = hexdec($color[0].$color[1]);
        $G = hexdec($color[2].$color[3]);
        $B = hexdec($color[4].$color[5]);

        $RGB['R'] = $R;
        $RGB['G'] = $G;
        $RGB['B'] = $B;

        return $RGB;
    }
	
	//------------------------GET SET JSON FILE-----------------------------//
	
	public static function getJSONDatas($file) {
		$s = file_get_contents($file);
		return json_decode($o, true);
	}
	
	public static function setJSONDatas($file, $o) {
		$myjson= json_encode($o);
		return self::write($myjson,$file);
	}
	
	public static function write($xml, $filename) {

		if(file_exists($filename)) {
			$f = fopen($filename.'.tmp', 'w'); # On ouvre le fichier temporaire
			fwrite($f, trim($xml)); # On écrit
			fclose($f); # On ferme
			unlink($filename);
			rename($filename.'.tmp', $filename); # On renomme le fichier temporaire avec le nom de l'ancien
		} else {
			$f = fopen($filename, 'w'); # On ouvre le fichier
			fwrite($f, trim($xml)); # On écrit
			fclose($f); # On ferme
		}
		# On place les bons droits
		chmod($filename,0644);
		# On vérifie le résultat
		if(file_exists($filename) AND !file_exists($filename.'.tmp'))
			return true;
		else
			return false;
	}
	
	//-------------------------FOLDER-----------------------------//
	
	public static function check_file_exist($filename){
		if (file_exists($filename)) {
    		return true;
		} else {
    		return false;
		}
	}
	
	# new dir
	public static function newDir($newdir) {
		if(!is_dir($newdir)) { # create folder if not exist
			if(!mkdir($newdir,0755))
				return false;
			else
				return true;
		} else {
			return false;
		}
    }
	
	# copy dir
	public static function copyDir($source,$destination) {
		if(!copy($source,$destination))
			return false;
		else
			return true;
    }
	
	public static function deleteFile($file) {
		if (!@unlink($file)) {
    		return false;
		}else{
			return true;
		}
	}
	
	public static function copyFile($file,$newfile) {
		if (!@copy($file, $newfile)) {
    		return false;
		}else{
			return true;
		}
	}
	
	public static function createFile($file,$content) {
		$f = fopen($file, "w");
        if($f==false)
            die("unable to create file");
		fwrite($f,$content);
        fclose ($f);
		return $file;
	}
	
	# merge multifile in one file
	// Array of css files
	/* $file = array(
		'file1.php',
		'file2.php',
		'file3.php',
		'file4.php'
	);
	
	merge_file( $file,"output.php");	
	*/
	public function merge_file( $a ,$myFile) {
		$fo = fopen($myFile, 'w') or die("can't open file");
		foreach ($a as $file) {
   			if (file_exists($file)) {
				$file_content = file_get_contents($file);
				fwrite($fo, $file_content);
			}
		}
		fclose($fo);
	}
	
	
}
?>