<?php
/**
 * Classe spxvisualwizardWidgets responsable de la gestion des widgets
 *
 * @package SPX
 * @author	je-evrard
 **/
class spxvisualwizardWidgets {


	public $aWidgets=array(); #tableau contenant les plugins
	public $aCatWidgets=array(); #tableau contenant la liste des cats
	public $default_lang=DEFAULT_LANG; # langue par defaut utilisée par PluXml
	public $path_medias;
	public $path_fullmedias;
	


	public $color_config;

	public static $aLang=array(); # tableau contenant les clés de traduction de la langue courante de PluXml
	public $aHeadcss= array(); #
	// public static $sHeadcss=''; #

	/**
	 * Constructeur de la classe spxvisualwizardWidgets
	 *
	 * @param	default_lang	langue par défaut utilisée par PluXml
	 * @return	null
	 * @author	je-evrard
	 **/
	public function __construct($default_lang='') {

		$this->default_lang=$default_lang;


		global $plxMotor;
		$plxMotor =  plxMotor::getInstance();
		$this->path_medias = isset($plxMotor->aConf['medias']) ? $plxMotor->aConf['medias'] : $plxMotor->aConf['images'];
		$this->path_fullmedias = PLX_ROOT.$this->path_medias;

		self::$aLang = $this->loadLang(PLX_PLUGINS.'spxvisualwizard/widgets/lang/'.$this->default_lang.'.php');
		if (self::$aLang==false) {
			self::$aLang = $this->loadLang(PLX_PLUGINS.'spxvisualwizard/widgets/lang/en.php');
		}
		//print_r(self::$aLang);

		$this->loadcolor();
	}

	/**
	 * Méthode qui charge le fichier de langue par défaut du plugin
	 *
	 * @param	filename	fichier de langue à charger
	 * @return	array		tableau contenant les clés de traduction
	 * @author	je-evrard
	 **/
	public function loadLang($filename) {
		if(!is_file($filename)) return false;
		include($filename);
		return $LANG;
	}

	/**
	 * Méthode qui affiche une clé de traduction dans la langue par défaut de PluXml
	 *
	 * @param	key		clé de traduction à récuperer
	 * @return	stdio
	 * @author	je-evrard
	 **/
	public static function lang($key='') {
		if(isset(self::$aLang[$key]))
			echo self::$aLang[$key];
		else
			echo $key;
	}

	/**
	 * Méthode qui retourne une clé de traduction dans la langue par défaut de PluXml
	 *
	 * @param	key		clé de traduction à récuperer
	 * @return	string	clé de traduite
	 * @author	je-evrard
	 **/
	public static function getLang($key='') {
		if(isset(self::$aLang[$key]))
			return self::$aLang[$key];
		else
			return $key;
	}

	/**
	 * Méthod to set a css in head
	 *
	 * @param	key		clé de traduction à récuperer
	 * @return	string	clé de traduite
	 * @author	je-evrard
	 **/
	public static function set_css_to_head($s) {
		//echo ("s1 = ".$s);
		//if (!isset($this->aHeadcss)) {
			//$this->aHeadcss = array();
		//}
		//array_push($this->aHeadcss, $s);
		//self::$sHeadcss .= $s;
		//echo ("selfsHeadcss".self::$sHeadcss);
		//print_r(self::$aHeadcss);
	}

	public function get_css_to_head() {
		//echo ("selfsHeadcss2".self::$sHeadcss);
		/*$a = array();
		$a[0]="coco css";
		return $a;*/
		//echo ("s2 = ");
		//print_r(self::$aHeadcss);
		// return self::$aHeadcss;
		//return $this->aHeadcss;
	}



	/**
	 * Méthode qui renvoit une instance d'un widget
	 *
	 * @param	widgetName	nom du widget
	 * @return	object		object de type plxWidget / false en cas d'erreur
	 * @return	null
	 * @author	je-evrard
	 **/
	public function getInstance($widgetName, $root='') {
		if ($root=='') {
			$filename = PLX_PLUGINS.'spxvisualwizard/widgets/widgets/'.$widgetName.'/'.$widgetName.'.php';
		}else{
			$filename = $root;
		}
		//echo ("widgetName=".$widgetName."\n<br>");
		//echo ("filename".$filename."\n<br>");
		if(is_file($filename)) {
			include_once($filename);
			$name2 = 'viw'.$widgetName;
			if (class_exists($widgetName) ) {
				return new $widgetName($this->default_lang);
			} else if (class_exists($name2)) {
				return new $name2($this->default_lang);
			}
		}
		return false;
	}

	/**
	 * Méthode qui scan les fichiers de plugins + theme
	 *
	 * @return	null
	 * @author	je-evrard
	 **/
	public function loadWidgets() {

		//$this->aWidgets["toto"]="tata";

		$root_widget= PLX_PLUGINS.'spxvisualwizard/widgets/widgets/';

		# liste des autres themes dispos
		$files = plxGlob::getInstance($root_widget, true);

		//print_r($files);
		if($widget = $files->query("/[a-z0-9-_\.\(\)]+/i", "", "sort")) {
			$count=0;
			foreach($widget as $k=>$name) {
				//echo ("name=".$name."\n<br>");
				// $this->aWidgets[$v]=$v;
				if($instance=$this->getInstance($name)) {
					//echo ("toto !!!!!"."\n<br>");
					$this->aWidgets[$name] = $instance;
				}else{
					//echo ("tata"."\n<br>");

				}
				$count++;
				//echo ("count=".$count);
				/*exit;*/
			}
		}


		# boucle dans les différents plugin + thème en cours
		# scan du folder spxvisualwizard/widgets/
		# plugins/pluginx/spxvisualwizard/widgets/ on fera plus tard
		/*
		for($i = 0; $i < $nb; $i++) {
			$name = $values[$iTags['plugin'][$i] ]['attributes']['name'];
			if($instance=$this->getInstance($name)) {
				$this->aPlugins[$name] = $instance;
			}
		}
		*/
	}

	/**
	 * Méthode qui effectue la liste des categories
	 *
	 * @return	null
	 * @author	je-evrard
	 **/
	public function createWidgetsCats() {
		$this->aCatWidgets = array();
		// $this->aCatWidgets["Cat1"]["button"]="button";
		// $this->aWidgets["button"]
		foreach($this->aWidgets as $name=>$widget) {
			$cat = $widget->category;
			$widgetName = $widget->name;
			if (empty($this->aCatWidgets[$cat]) or !is_array($this->aCatWidgets[$cat]) )
				$this->aCatWidgets[$cat]=array();
			$this->aCatWidgets[$cat][$widgetName]=$widgetName;
			// echo ("widgetName = ".$widgetName);
		}

		//print_r($this->aCatWidgets);
	}




	/**
	 * Méthode qui récupère les infos des widgets
	 *
	 * @return	null
	 * @author	je-evrard
	 **/
	public function getInfos() {
		foreach($this->aWidgets as $widgetName => $widgetInstance) {
			$widgetInstance->getInfos();
		}
	}


	/**
	 * Méthode qui génère le fichier css admin.css ou site.css
	 *
	 * @param	type		type du fichier (admin|site)
	 * @return	boolean		vrai si cache généré
	 * @author	je-evrard
	 **/
	public function cssCache($type) {

	}

	/**
	 * Méthode qui génère le fichier css admin.css ou site.css
	 *
	 * @param	type		type du fichier (admin|site)
	 * @return	boolean		vrai si cache généré
	 * @author	je-evrard
	 **/
	public function loadcolor() {
		$filename = PLX_PLUGINS.'spxvisualwizard/admin/color_config.php';
		if(is_file($filename)) {
			include_once($filename);
			$this->color_config = $viwcolor;
		}
	}

	public function getcolorconfig() {
		return $this->color_config;
	}



}

/**
 * Classe plxPlugin destiné à créer un widget
 *
 * @package SPX
 * @author	je-evrard
 **/
class spxvisualwizardWidget {

	protected $aInfos=array();  # tableau des infos sur le plugins venant du fichier infos.xml
	protected $aParams=array(); # tableau des paramètres sur le plugins venant du fichier parameters.xml

	protected $aLang=array(); # tableau contenant les clés de traduction de la langue courante de PluXml

	protected $wid=array(); # tableau contenant des infos diverses pour le fonctionnement du widget

	public $default_lang=DEFAULT_LANG; # langue par defaut de PluXml

	public $icon = '';
	public $name = '';
	public $title = '';
	public $widgetname = '';
	public $description = '';
	public $category = '';
	public $dependencies = array();
	public $default_options = array();

	public $child = '';
	public $aChild = array();
	//public $parent = '';



	# https://wpbakery.atlassian.net/wiki/pages/viewpage.action?pageId=524332#

	/**
	 * Constructeur de la classe plxPlugin
	 *
	 * @param	default_lang	langue par défaut utilisée par PluXml
	 * @return	null
	 * @author	Stephane F
	 **/
	public function __construct($default_lang='',$root_widget='', $theparent='') {
		// echo ("coucou");

		if ($root_widget='' ) $root_widget= PLX_PLUGINS.'spxvisualwizard/widgets/';
		$this->default_lang = $default_lang;


		$widgetName= get_class($this);
		$this->widgetname = get_class($this);

		$this->wid = array(
			'dir' 			=> $root_widget,
			'name' 			=> $widgetName,
			'filename'		=> $root_widget.$widgetName.'/'.$widgetName.'.php',
		);
		//$this->aLang = $this->loadLang($root_widget.'/lang/'.$this->default_lang.'.php');
		$this->loadParams();



		//echo ("tator !!!!!");
		//$this->getChild();
	}



	/**
	 * Méthode qui retourne une instance de classe enfant
	 *
	 * @param	aucun
	 * @return	instance de class
	 * @author	Evrard je
	 **/
	public function getChild() {

		if ($this->child !=''){

			$name = $this->child;
			$name2 = 'viw'.$this->child;
			if (class_exists($name) ) {
				$this->aChild[$name] = new $name($this->default_lang, '', $this);
			} else if (class_exists($name2)) {
				$this->aChild[$name] = new $name2($this->default_lang, '', $this);

				/*echo ("<pre>");
				print_r($this->aChild);
				echo ("</pre>");*/
			}
		}
		return false;
	}

	/**
	 * Méthode qui charge le fichier des parametres du plugin parameters.xml
	 *
	 * @return	null
	 * @author	Stephane F
	 **/
	public function loadParams() {


	}

	/**
	 * Méthode qui renvoie le tableau des paramètres
	 *
	 * @return	array		tableau aParams
	 * @author	Stephane F
	 **/
	public function getParams() {
		if(sizeof($this->aParams)>0)
			return $this->aParams;
		else
			return false;
	}

	/**
	 * Méthode qui renvoie la valeur d'un parametre du fichier parameters.xml
	 *
	 * @param	param	nom du parametre à recuperer
	 * @return	string	valeur du parametre
	 * @author	Stephane F
	 **/
	public function getParam($param) {
		return (isset($this->aParams[$param])? $this->aParams[$param]['value']:'');
	}

	/**
	 * Méthode qui recupere les données du fichier infos.xml
	 *
	 * @return	null
	 * @author	Stephane F
	 **/
	public function getInfos() {

	}

	public function get_options($options) {
		return $options;

	}

	/* from widget __construct $this->default_options = */
	public function merge_advanced_default_options( $o ){
		$o2 = array(
			'adv_dr' => '',
			'adv_anim' => '',
			'adv_animd' => '',
			'adv_id' => '',
			'adv_cl' => '',
			# custom margin
			'adv_mc' => '',
			'adv_mt' => '0',
			'adv_mb' => '0',
			'adv_mr' => '0',
			'adv_ml' => '0',
			'adv_mun' => ''
		);
		return array_merge($o, $o2);

	}
	public function get_o_advanced_options_front( $atts ){
		extract( shortcode_atts( $this->default_options, $atts ) );
		/*
				'adv_dr' => '',
				'adv_anim' => '',
				'adv_id' => '',
				'adv_cl' => '',
				'adv_mt' => '',
				'adv_mb' => '',
				'adv_mr' => '',
				'adv_ml' => '',
				*/
		$o = array();
		$o["class"]=' ';
		$o["extra"] = '';
		if (!empty($atts["adv_cl"]))
			$o["class"].=$atts["adv_cl"].' ';
		if (!empty($atts["adv_anim"])) {
			$o["class"].="wow ".$atts["adv_anim"].' ';
		}
		if (!empty($atts["adv_dr"]))
			$o["class"].=$atts["adv_dr"].' ';

		$o["id"]='';
		if (!empty($atts["adv_id"]))
			$o["id"]= ' id="'.$atts["adv_id"].'" ';

		$margin_unit = "px";
			if (!empty($atts["adv_mun"])) $margin_unit = $atts["adv_mun"];
		$o["style"]='';

		if (isset($atts["adv_mc"]) and $atts["adv_mc"]=="1") {
			//if ($atts["adv_mt"]!='' )
				$o["style"] .= ' margin-top:'.$atts["adv_mt"].$margin_unit.'; ';
			//if ($atts["adv_mb"]!='')
				$o["style"] .= ' margin-bottom:'.$atts["adv_mb"].$margin_unit.'; ';
			//if ($atts["adv_mr"]!='' )
				$o["style"] .= ' margin-right:'.$atts["adv_mr"].$margin_unit.'; ';
			//if (intval($atts["adv_ml"])!='' )
				$o["style"] .= ' margin-left:'.$atts["adv_ml"].$margin_unit.'; ';
		}


		$o["style2"] = isset($o["style"])?' style="'.$o["style"].'" ': '';

		if (isset($atts["adv_animd"]) and intval ($atts["adv_animd"])>0) {
			$sec = $atts["adv_animd"]/1000;
			$o["extra"].=' data-wow-delay="'.$sec.'s" ';
		}

		return $o;

	}
	public function shortcode_advanced_options( $atts ){
		extract( shortcode_atts( $this->default_options, $atts ) );

			# toggle bg type
			$atoggle_margin_custom = array (
				'' => array (),
				'1' => array (
					'field' => array (
						'adv_mt',
						'adv_mb',
						'adv_mr',
						'adv_ml',
						'adv_mun'
					),
				),
			);

			$ajsontoggle_margin_custom = htmlspecialchars(json_encode($atoggle_margin_custom), ENT_QUOTES, 'UTF-8');



			$options = array(
				array(
					'title' => $this->__( 'Responsive', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),

				array(
					'param_name' => 'adv_dr',
					'title' => $this->__( 'Show on device', 'spxvisualwizard' ),
					'desc' => "",
					'type' => 'select',
					'selected' => $adv_dr,
					'data' => array(
						'' => "All",
						'vwi_h-sml' => "PC and tablet",
						'vwi_h-med' => "PC and mobile",
						'vwi_h-lrg' => "Tablet and mobile",
						'vwi_h-med vwi_h-lrg' => "Mobile only",
						'vwi_h-sml vwi_h-lrg' => "Tablet only",
						'vwi_h-sml vwi_h-med' => "PC only",
						'vwi_h-sml vwi_h-med vwi_h-lrg' => "No device",

					),
				),

				array(
					'title' => $this->__( 'Display', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),
				// view-source:https://daneden.github.io/animate.css/
				array(
					'param_name' => 'adv_anim',
					'title' => "Animation",
					'desc' => "",
					'type' => 'select2group',
					'selected' => $adv_anim,
					'data' => array(
						'No animation' => array(
						  '' => 'None',
						  ),
						 'Attention Seekers' => array(
						  'bounce' => 'bounce',
						  'flash' => 'flash',
						  'pulse' => 'pulse',
						  'rubberBand' => 'rubberBand',
						  'shake' => 'shake',
						  'swing' => 'swing',
						  'tada' => 'tada',
						  'wobble' => 'wobble',
						  'jello' => 'jello',

						),

						'Bouncing Entrances' => array(

						  'bounceIn' => 'bounceIn',
						  'bounceInDown' => 'bounceInDown',
						  'bounceInLeft' => 'bounceInLeft',
						  'bounceInRight' => 'bounceInRight',
						  'bounceInUp' => 'bounceInUp',

						),

						'Bouncing Exits' => array(


						  'bounceOut' => 'bounceOut',
						  'bounceOutDown' => 'bounceOutDown',
						  'bounceOutLeft' => 'bounceOutLeft',
						  'bounceOutRight' => 'bounceOutRight',
						  'bounceOutUp' => 'bounceOutUp',

						),

						'Fading Entrances' => array(

						  'fadeIn' => 'fadeIn',
						  'fadeInDown' => 'fadeInDown',
						  'fadeInDownBig' => 'fadeInDownBig',
						  'fadeInLeft' => 'fadeInLeft',
						  'fadeInLeftBig' => 'fadeInLeftBig',
						  'fadeInRight' => 'fadeInRight',
						  'fadeInRightBig' => 'fadeInRightBig',
						  'fadeInUp' => 'fadeInUp',
						  'fadeInUpBig' => 'fadeInUpBig',
						),

						'Fading Exits' => array(


						  'fadeOut' => 'fadeOut',
						  'fadeOutDown' => 'fadeOutDown',
						  'fadeOutDownBig' => 'fadeOutDownBig',
						  'fadeOutLeft' => 'fadeOutLeft',
						  'fadeOutLeftBig' => 'fadeOutLeftBig',
						  'fadeOutRight' => 'fadeOutRight',
						  'fadeOutRightBig' => 'fadeOutRightBig',
						  'fadeOutUp' => 'fadeOutUp',
						  'fadeOutUpBig' => 'fadeOutUpBig',

						),

						'Flippers' => array(

						  'flip' => 'flip',
						  'flipInX' => 'flipInX',
						  'flipInY' => 'flipInY',
						  'flipOutX' => 'flipOutX',
						  'flipOutY' => 'flipOutY',

						),

						'Lightspeed' => array(


						  'lightSpeedIn' => 'lightSpeedIn',
						  'lightSpeedOut' => 'lightSpeedOut',


						),

						'Rotating Entrances' => array(


						  'rotateIn' => 'rotateIn',
						  'rotateInDownLeft' => 'rotateInDownLeft',
						  'rotateInDownRight' => 'rotateInDownRight',
						  'rotateInUpLeft' => 'rotateInUpLeft',
						  'rotateInUpRight' => 'rotateInUpRight',

						),

						'Rotating Exits' => array(


						  'rotateOut' => 'rotateOut',
						  'rotateOutDownLeft' => 'rotateOutDownLeft',
						  'rotateOutDownRight' => 'rotateOutDownRight',
						  'rotateOutUpLeft' => 'rotateOutUpLeft',
						  'rotateOutUpRight' => 'rotateOutUpRight',
						),

						'Sliding Entrances' => array(


						  'slideInUp' => 'slideInUp',
						  'slideInDown' => 'slideInDown',
						  'slideInLeft' => 'slideInLeft',
						  'slideInRight' => 'slideInRight',

						),

						'Sliding Exits' => array(


						  'slideOutUp' => 'slideOutUp',
						  'slideOutDown' => 'slideOutDown',
						  'slideOutLeft' => 'slideOutLeft',
						  'slideOutRight' => 'slideOutRight',

						),

						'Zoom Entrances' => array(


						  'zoomIn' => 'zoomIn',
						  'zoomInDown' => 'zoomInDown',
						  'zoomInLeft' => 'zoomInLeft',
						  'zoomInRight' => 'zoomInRight',
						  'zoomInUp' => 'zoomInUp',

						),

						'Zoom Exits' => array(


						  'zoomOut' => 'zoomOut',
						  'zoomOutDown' => 'zoomOutDown',
						  'zoomOutLeft' => 'zoomOutLeft',
						  'zoomOutRight' => 'zoomOutRight',
						  'zoomOutUp' => 'zoomOutUp',

						),

						'Specials' => array(

						  'hinge' => 'hinge',
						  'rollIn' => 'rollIn',
						  'rollOut' => 'rollOut',

						),






					),
				),

				array(
					'param_name' => 'adv_animd',
					'title' => $this->__( 'Delay in milliseconds', 'spxvisualwizard' ),
					'type' => 'sliderMinMax',
					'value' => $adv_animd,
					'step' => '100',
					'min' => '0',
					'max' => '10000',
				),



				array(
						'param_name' => 'adv_id',
						'title' => $this->__( 'CSS ID', 'spxvisualwizard' ),
						'desc' => '',
						'type' => 'text',
						'value' => $adv_id,
					),

				array(
						'param_name' => 'adv_cl',
						'title' => 'CSS Class',
						'desc' => '',
						'type' => 'text',
						'value' => $adv_cl,
					),

				array(
					'title' => $this->__( 'Margin', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),

				array(
					'param_name' => 'adv_mc',
					'title' => $this->__( 'Default or custom margin', 'spxvisualwizard' ),
					'desc' => "",
					'type' => 'select',
					'selected' => $adv_mc,
					'innerextra' => ' data-toggle="'.$ajsontoggle_margin_custom .'" ',
					'class' => 'viw_ui-needtoggle',
					'data' => array(
						'' => "Default",
						'1' => "Custom",
					),
				),

				array(
					'param_name' => 'adv_mt',
					'title' => $this->__( 'Margin top', 'spxvisualwizard' ),
					'type' => 'sliderMinMax',
					'value' => $adv_mt,
					'min' => '-400',
					'max' => '400',
				),

				array(
					'param_name' => 'adv_mb',
					'title' => $this->__( 'Margin bottom', 'spxvisualwizard' ),
					'type' => 'sliderMinMax',
					'value' => $adv_mb,
					'min' => '-400',
					'max' => '400',
				),

				/*array(
					'param_name' => 'adv_mr',
					'title' => $this->__( 'Margin right', 'spxvisualwizard' ),
					'type' => 'sliderMinMax',
					'value' => $adv_mr,
					'min' => '0',
					'max' => '400',
				),

				array(
					'param_name' => 'adv_ml',
					'title' => $this->__( 'Margin left', 'spxvisualwizard' ),
					'type' => 'sliderMinMax',
					'value' => $adv_ml,
					'min' => '0',
					'max' => '400',
				),

				array(
					'param_name' => 'adv_mun',
					'title' => "Margin unit",
					'desc' => "",
					'type' => 'select',
					'selected' => $adv_mun,
					'data' => array(
						'px' => "px",
						'%' => "percent",
					),
				),
				*/

			);

			switch ($this->name) {
				case "section":
				case "row":
				case "col":
					$options2 = array (

						array(
							'param_name' => 'adv_mun',
							'title' => "Margin unit",
							'desc' => "",
							'type' => 'select',
							'selected' => $adv_mun,
							'data' => array(
								'px' => "px",
								'%' => "percent",
							),
						),

					);
					break;

				default:
					$options2 = array (

						array(
							'param_name' => 'adv_ml',
							'title' => $this->__( 'Margin left', 'spxvisualwizard' ),
							'type' => 'sliderMinMax',
							'value' => $adv_ml,
							'min' => '-400',
							'max' => '400',
						),

						array(
							'param_name' => 'adv_mr',
							'title' => $this->__( 'Margin right', 'spxvisualwizard' ),
							'type' => 'sliderMinMax',
							'value' => $adv_mr,
							'min' => '-400',
							'max' => '400',
						),

						array(
							'param_name' => 'adv_mun',
							'title' => "Margin unit",
							'desc' => "",
							'type' => 'select',
							'selected' => $adv_mun,
							'data' => array(
								'px' => "px",
								'%' => "percent",
							),
						),

					);

					break;
			}



			/*$test = array_merge($options, $options2);
			echo ("<pre>");
			print_r($test);
			echo ("</pre>");*/


		return $this->get_advanced_options(array_merge($options, $options2));
	}

	public function get_advanced_options($options) {
		return $options;
	}

	public function __($s, $domain='spxvisualwizard') {
		return spxvisualwizardWidgets::getLang($s);
	}

	public function template_wireframe_formatter() {
		return false;
	}
	public function template_preview() {
		return false;
	}
	public function template_wireframe() {
		return false;
	}
	public function set_css_to_head($s) {
		//spxvisualwizardWidgets::set_css_to_head($s);
	}

	/*
	public function set_frontend_atts( $atts){
		return false;
	}

	public function get_frontend_att($s){
		return false;
	}
	*/

}
?>