<?php

class spxvisualwizard extends plxPlugin {

	/**
	 * Constructeur de la classe
	 *
	 * @param	default_lang	langue par défaut utilisée par PluXml
	 * @return	null
	 * @authors	je-evrard
	 **/

	public $spxvisualwizardWidgets = null; # Objet plxPlugins
	public $spxname;

	public function __construct($default_lang) {
		#error_reporting(0);
		/*

		// Désactiver le rapport d'erreurs
		error_reporting(0);

		// Rapporte les erreurs d'exécution de script
		error_reporting(E_ERROR | E_WARNING | E_PARSE);

		// Rapporter les E_NOTICE peut vous aider à améliorer vos scripts
		// (variables non initialisées, variables mal orthographiées..)
		error_reporting(E_ERROR | E_WARNING | E_PARSE | E_NOTICE);

		// Rapporte toutes les erreurs à part les E_NOTICE
		// C'est la configuration par défaut de php.ini
		error_reporting(E_ALL & ~E_NOTICE);

		// Reporte toutes les erreurs PHP (Voir l'historique des modifications)
		error_reporting(E_ALL);

		// Reporte toutes les erreurs PHP
		error_reporting(-1);

		// Même chose que error_reporting(E_ALL);
		ini_set('error_reporting', E_ALL);

		*/



		# Appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);

		# add shorcode
		$this->setParam('spxshortcodes_shortcode', '1', 'string');

		# droits pour accéder à la page config.php du plugin
		$this->spxname="spxvisualwizard";
		if (!defined('VIW_URL')) define('VIW_URL', PLX_PLUGINS.$this->spxname);

		$this->setConfigProfil(PROFIL_ADMIN);
		#$this->initconfiguration();
		$this->addHook('plxMotorConstruct', 'initconfiguration');

		# Déclarations des hooks
		if(defined('PLX_ADMIN')) {
			if(preg_match('/(article|statique|categorie)/', basename($_SERVER['SCRIPT_NAME']))) {
				$this->addHook('AdminPrepend', 'AdminPrepend');
				$this->addHook('AdminTopEndHead', 'AdminTopEndHeadVIW');
				$this->addHook('AdminFootEndBody', 'AdminFootEndBody');
			}
		}

		if(!defined('PLX_ADMIN')) {
			// loadshortcodes + initwidgets
			$this->addHook('IndexBegin', 'IndexBegin');
			// do_shortcode output
			$this->addHook('IndexEnd', 'IndexEnd');
			$this->addHook('ThemeEndHead', 'addCssLibrairy');
			$this->addHook('ThemeEndBody', 'addJSlibrairy');
		}
	}

	/**
	 * Méthode qui initialise les variables
	 *
	 * @author	JE-EVRARD, Thomas I.
	 **/
	public function initconfiguration() {

		# VARIOUS PARAMS
		$this->setParam('spxshortcodes_shortcode', '1', 'string');

		if (plxUtils::strCheck($this->getParam('viwfontdefault'))=="")
			$this->setParam("viwfontdefault", "Sans-serif", 'string');
		if (plxUtils::strCheck($this->getParam('viwcontainerwidth'))=="")
			$this->setParam("viwcontainerwidth", 1280, 'numeric');
		if (plxUtils::strCheck($this->getParam('viwcsslargedevice'))=="")
			$this->setParam("viwcsslargedevice", 1024, 'numeric');
		if (plxUtils::strCheck($this->getParam('viwcssmediumdevice'))=="")
			$this->setParam("viwcssmediumdevice", 768, 'numeric');
		if (plxUtils::strCheck($this->getParam('viwpost'))=="")
			$this->setParam("viwpost", 1, 'numeric');
		if (plxUtils::strCheck($this->getParam('viwpage'))=="")
			$this->setParam("viwpage", 1, 'numeric');

		if (!defined('VIW_CONTAINERWIDTH'))  define('VIW_CONTAINERWIDTH', $this->getParam('viwcontainerwidth'));
		#$plxMotor =  plxMotor::getInstance(); fix infinite loop
		echo '<?php '; ?>
		$basepath_image = isset($this->aConf['medias']) ? $this->aConf['medias'] : $this->aConf['images'];
		// use by widget section and row
		if (!defined('VIW_BASEPATHIMAGE'))  define('VIW_BASEPATHIMAGE', $basepath_image);
		if (!defined('VIW_ROOTBASEPATHIMAGE'))  define('VIW_ROOTBASEPATHIMAGE', PLX_ROOT.$basepath_image);
?><?php
	}

	# include shorcode librairy and parse all
	public function IndexBegin() {
		$this->loadshortcodes();

		/* SPXSHORTCODES */
		# inclusion de shortcode venant de plugin externe
		$this->addons_shortcode_plugins();
		# Chargement du fichier de config du theme comprenant la declaration des shorcodes
		$plxMotor = plxMotor::getInstance();
		$configtheme = PLX_ROOT.$plxMotor->aConf['racine_themes'].$plxMotor->style.'/config.php';
		if(file_exists($configtheme) AND filesize($configtheme) > 0) {
			require($configtheme);
		}
		/* END SPXSHORTCODES */



		$this->initwidgets() ;
	}

	# add utils class
	public function AdminPrepend() {
		//echo ("load shortcodes and init widget !!!");
		$this->loadshortcodes();
		$this->initwidgets() ;
	}

	# include shorcode librairy and parse all
	public function loadshortcodes() {

		if (!function_exists('add_shortcode')) {
			function add_filter() {}
			require(PLX_PLUGINS.$this->spxname.'/assets/wp/shortcodes.php');
		}
	}

	# add utils class
	public function loadlib() {
		require_once(dirname(__FILE__).'/lib/class.spxvisualwizard.widgets.php');
		require_once(dirname(__FILE__).'/lib/class.spx.form.php');
		require_once(dirname(__FILE__).'/lib/class.spxvisualwizard.utils.php');
		require_once(dirname(__FILE__).'/lib/class.spxvisualwizard.ressource.php');
		require_once(dirname(__FILE__).'/lib/class.spx.displayform.php');
		require_once(dirname(__FILE__).'/externalclass/color.php');
	}

	public function initwidgets() {
		# Traitement des widgets
		//echo ("init widgets");
		$this->loadlib();
		//echo ("default language = ".$this->default_lang);
		$this->spxvisualwizardWidgets = new spxvisualwizardWidgets($this->default_lang);
		$this->spxvisualwizardWidgets->loadWidgets();
		$this->spxvisualwizardWidgets->createWidgetsCats();
	}

	public function addCssLibrairy() {
		$s= "

		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/assets/wow/animate.css' media='screen' />

		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/assets/fontawesome/font-awesome.min.css' media='screen' />

		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/widgets/vwifront.css' media='screen' />



		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/widgets/vwifrontflex.css' media='screen' />



		";

		echo $s;






		// check if data/visualwizard/css/vwiconfig.css exist ?
		if (file_exists(PLX_ROOT."data/visualwizard/css/vwiconfig.css")){
			$s= "<link rel='stylesheet' type='text/css' href='./".PLX_ROOT."data/visualwizard/css/vwiconfig.css' media='screen' />";
			echo $s;
		}else{
			$s= "<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/widgets/vwiconfig.css' media='screen' />";
			echo $s;
		}

		// $a = $this->get_css_to_head();
		//$a = $this->get_css_to_head();
		//echo $mytest;
		//print_r($mytest);
		//for ($i=0; $i<count($a); $i++){
			//echo $a[$i];
		//}


		echo "\n".'



		<script type="text/javascript">
		/* <![CDATA[ */
		!window.jQuery && document.write(\'<script  type="text/javascript" src="'.PLX_PLUGINS.$this->spxname.'/assets/jquery/jquery-2.1.3.min.js"><\/script>\');
		/* !]]> */
		</script>


		<script type="text/javascript" src="'.PLX_PLUGINS.$this->spxname.'/assets/parallax.js-1.4.2/parallax.min.js" ></script>
		<script type="text/javascript" src="'.PLX_PLUGINS.$this->spxname.'/assets/tubeplayer/jQuery.tubeplayer.min.js" ></script>

		<link rel="stylesheet" href="'.PLX_PLUGINS.$this->spxname.'/assets/wow/animate.css">
		<script src="'.PLX_PLUGINS.$this->spxname.'/assets/wow/wow.min.js"></script>
        <script>
            new WOW().init();
        </script>

		<script src="https://cdnjs.cloudflare.com/ajax/libs/geopattern/1.2.3/js/geopattern.min.js"></script>
		<script src="'.PLX_PLUGINS.$this->spxname.'/assets/imagesloaded/imagesloaded.pkgd.min.js"></script>
		<script src="'.PLX_PLUGINS.$this->spxname.'/assets/anime/anime.min.js"></script>
		<script src="'.PLX_PLUGINS.$this->spxname.'/assets/segmenter/segmenter.js"></script>
		<script src="'.PLX_PLUGINS.$this->spxname.'/admin/js/shortlib/viw-utils.js"></script>

		';
	}

	public function addJSlibrairy() {
		echo "\n".'
		<script type="text/javascript" src="'.PLX_PLUGINS.$this->spxname.'/widgets/vwifront.js" ></script>
		';
	}

	# parse shorcode in output
	public function IndexEnd() {
		$string = '
			$output = do_shortcode($output);
		';
		echo '<?php '.$string.' ?>';
	}

	# add css and js
	public function AdminTopEndHeadVIW() {
		$plxMotor =  plxMotor::getInstance();
		$basepath_image = isset($plxMotor->aConf['medias']) ? $plxMotor->aConf['medias'] : $plxMotor->aConf['images'];

		//$plxMotor = plxMotor::getInstance();
		$page_type= "artice";
		$page_id = "";
		//echo ("PLX_ADMIN = ".PLX_ADMIN);
		if((defined("PLX_ADMIN") && preg_match("/statique.php/", $_SERVER["REQUEST_URI"]))) {
			$page_type = "statique";
			if(!empty($_GET['p'])){
				$page_id = plxUtils::strCheck(plxUtils::nullbyteRemove($_GET['p']));
			}
		} else if ((defined("PLX_ADMIN") && preg_match("/article.php/", $_SERVER["REQUEST_URI"]))) {
			$page_type = "article";
			if(!empty($_GET['a'])){
				$page_id = plxUtils::strCheck(plxUtils::nullbyteRemove($_GET['a']));
			}
		} else if ((defined("PLX_ADMIN") && preg_match("/categorie.php/", $_SERVER["REQUEST_URI"]))) {
			$page_type = "categorie";
			if(!empty($_GET['p'])){
				$page_id = plxUtils::strCheck(plxUtils::nullbyteRemove($_GET['p']));
			}
		}


		$this->addCssLibrairy();
		$this->addJSlibrairy();

		$s= "

		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/wp/underscore.min.js' ></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/wp/shortcode.js' ></script>

		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/assets/jquery-ui/jquery-ui.min.css' media='screen' />

		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/jquery/jquery-1.8.3.min.js' ></script>

		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/jquery-ui/jquery-ui.min.js' ></script>




		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/assets/trumbowyg/ui/trumbowyg.min.css' media='screen' />
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/trumbowyg/trumbowyg.min.js'></script>

		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/trumbowyg/plugins/colors/trumbowyg.colors.js'></script>
		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/assets/trumbowyg/plugins/colors/ui/trumbowyg.colors.css' media='screen' />

		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/trumbowyg/plugins/table/trumbowyg.table.min.js'></script>








		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/assets/fancybox/jquery.fancybox-1.3.4.css' media='screen' />

		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/fancybox/jquery.fancybox-1.3.4.js'></script>

		<link rel='stylesheet' type='text/css' href='".PLX_PLUGINS.$this->spxname."/assets/jPicker/css/jpicker-1.1.6.min.css' />

  		<script src='".PLX_PLUGINS.$this->spxname."/assets/jPicker/jpicker-1.1.6.js' type='text/javascript'></script>

		<script src='".PLX_PLUGINS.$this->spxname."/assets/matchheight/jquery.matchHeight.js' type='text/javascript'></script>



		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/assets/iconpicker/icon-picker.min.css' media='screen' />
		<script src='".PLX_PLUGINS.$this->spxname."/assets/iconpicker/icon-picker.min.js' type='text/javascript'></script>


		<link rel='stylesheet' type='text/css' href='".PLX_PLUGINS.$this->spxname."/assets/select2-4.0.0/css/select2.min.css' />
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/select2-4.0.0/js/select2.min.js' ></script>

		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/tinycolor/tinycolor.js' ></script>

		<script src='https://cdnjs.cloudflare.com/ajax/libs/geopattern/1.2.3/js/geopattern.min.js'></script>

		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/widgets/vwifrontflex.css' media='screen' />

		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/admin/css/visualwizard_ui.css' media='screen' />
		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/admin/css/visualwizard_sidebar_ui.css' media='screen' />


		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/mustache/mustache.min.js'></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/mustache/mustache-wax.min.js'></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/shortlib/viw-mustacheformatters.js' ></script>


		<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS.$this->spxname."/assets/perfectscrollbar/perfect-scrollbar.min.css' media='screen' />
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/assets/perfectscrollbar/perfect-scrollbar.jquery.min.js' ></script>




		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/jquery/viw-template.js' ></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/jquery/viw-section.js' ></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/jquery/viw-row.js' ></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/jquery/viw-col.js' ></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/jquery/viw-widget.js' ></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/shortlib/viw-utils.js' ></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/shortlib/viw-font.js' ></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/jquery/viw-idd.js' ></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/jquery/viw-cwdd.js' ></script>
		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/jquery/viw-sidebar.js' ></script>

		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/admin/js/shortlib/viw-visual-wizard.js' ></script>


		<script type='text/javascript' src='".PLX_PLUGINS.$this->spxname."/widgets/vwifront.js' ></script>



		";







		/* http://www.dyn-web.com/tutorials/php-js/json/array.php */
		/*
		$widget = array(
			"button" => array(
				"type" => "coco"
			)
		);
		*/
		/* prepare widgets output (remove achild recursive array) */
		$widget = $this->getWidgets();
		foreach ($widget as $wis => $wi) {
			// echo "Clé : $key; Valeur : $value<br />\n";
			// remove recursive array
			if (isset ($wi->aChild) && count ($wi->aChild)>0){
				unset ($widget[$wis]->aChild);
			}
		}
		/* prepare visualwizardconfig */
		$aconfig = array();
		$aconfig["viwfontdefault"] = $this->getParam('viwfontdefault');
		$aconfig["viwcontainerwidth"] = $this->getParam('viwcontainerwidth');
		$aconfig["viwpost"] = $this->getParam('viwpost');
		$aconfig["viwpage"] = $this->getParam('viwpage');
		$aconfig["viwcategorie"] = $this->getParam('viwcategorie');

		/*echo ("<pre>");
		print_r($widget);
		echo ("</pre>");*/

		$acolorconfig = $this->getcolorconfig();
		spxdisplayForm::setColorConfig($acolorconfig);
		//spxdisplayForm::setLang($spxvisualwizard->getUILanguage());

		$aviw_prop = array(
			"root_plugins" => PLX_PLUGINS.$this->spxname."/",
			"root" => PLX_ROOT,
			"root_admin" => PLX_PLUGINS.$this->spxname."/admin/",
			"root_config" => PLX_ROOT."core/admin/parametres_plugin.php?p=".$this->spxname,
			"basepath_image" => $basepath_image,
			"root_basepath_image" => PLX_ROOT.$basepath_image,
			"page_type" => $page_type,
			"page_id" => $page_id,
			"widget" => $widget,
			"fonts" => $this->getFonts(),
			"config" => $aconfig,
			"loc" => $this->aLang,
			"colors" => spxdisplayForm::getColorConfigformName()
		);



		$ajsviw_prop = json_encode($aviw_prop);

		/*echo ("<pre>");
		print_r($aviw_prop);
		echo ("</pre>");
		exit;*/
		echo '
		<script type="text/javascript">
		var VIWPROP = '.$ajsviw_prop.';
		/* var VIWPROP = {
			"root_plugins": "..\/..\/plugins\/spxvisualwizard",
			...
		}; */
		//alert(VIWPROP.widget.button.name);
		//console.dir (VIWPROP.widget.button.default_options.color);
		//console.dir (VIWPROP.widget["button"].default_options["color"]);
		</script>

		<script id="id_viw_template_widget_base" type="x-tmpl-mustache">
			<div class="viw_ui-widget-title-container">
				<div class="viw_ui-widget-icon-container">
					<span class="viw_ui-widget-icon viw_ui-widget-icon-{{ type }}"></span>
				</div>
				{{ type | uppercase }}
			</div>
			<div class="viw_ui-widget-label viw_truncate" >{{ content }}</div>
		</script>

		';


		echo $s;


		foreach ($widget as $wis => $wi) {
			$wi->template_wireframe_formatter();
			$wi->template_wireframe();
			$wi->template_preview();
		}

	}

	# add css and js
	public function getFonts() {
		$font= array(
		"Arial"=>"System",
		"Tahoma"=>"System",
		"Advent Pro"=>"googlefonts"
		);
		return $font;
	}
	# add css and js
	public function AdminFootEndBody() {
		// https://themeforest.net/forums/thread/looking-for-fontawesome-430-font-list-array-heres-it/172299
		// http://arnique.net/web-design/73/a-cool-use-of-regex-extracting-and-displaying-icon-fonts-like-font-awesome/
		echo '
		<div class="fa-set icon-set">
			<ul>


			</ul>
		</div>
		';
	}

	# return list of widgets
	public function getWidgets() {
		return $this->spxvisualwizardWidgets->aWidgets;
	}

	# return list of widgets
	public function getCatWidgets() {
		return $this->spxvisualwizardWidgets->aCatWidgets;
	}

	# return list of widgets
	public function getcolorconfig() {
		return $this->spxvisualwizardWidgets->color_config;
	}

	# return head css
	public function get_css_to_head() {
		return $this->spxvisualwizardWidgets->get_css_to_head();
	}

	# return lang for form
	public function getUILanguage() {
		return $this->aLang;
	}

	# add shortcode from external plugin
	private  function addons_shortcode_plugins() {
		$plxMotor = plxMotor::getInstance();
		$tmp = $plxMotor->plxPlugins->aPlugins;

		foreach($tmp as $key => $value) {
			//echo ("key=".$key);
			if ($value->getParam("spxshortcodes_shortcode")=="1"){
				$path = PLX_PLUGINS.$key.'/spxshortcodes/config.php';
				if(is_file($path)) {
					require($path);
				}
			}
		}
	}



	/* l'idee est de pouvoir depuis les widget faire de l'injection de code comme par exemple le code facebook qui ne doit etre le qu'une seule fois

	wordpress : wp_enqueue_script('scriptboostrap', get_bloginfo( 'template_url' ).'/js/bootstrap.min.js');


		1) doit etre injecte dans le theme
		2) doit etre injecté dans l'admin pour la preview
		3) l'idée est d'utiliser
			HEADER
			- ThemeEndHead
			- AdminTopEndHead
			BODY
			- ThemeEndBody
			- AdminFootEndBody



	thème
	-----

	Index
	IndexBegin

	ThemeEndHead
	ThemeEndBody

	IndexEnd

	admin
	-----

	top.php

	AdminTopEndHead
	AdminTopMenus
	AdminTopBottom

	foot.php

	AdminFootEndBody

	function.wp-scripts.php

	function wp_scripts() {
		global $wp_scripts;
		if ( ! ( $wp_scripts instanceof WP_Scripts ) ) {
			$wp_scripts = new WP_Scripts();
		}
		return $wp_scripts;
	}

	function wp_enqueue_script( $handle, $src = '', $deps = array(), $ver = false, $in_footer = false ) {
		$wp_scripts = wp_scripts();

		_wp_scripts_maybe_doing_it_wrong( __FUNCTION__ );


		if ( $src || $in_footer ) {
			$_handle = explode( '?', $handle );

			if ( $src ) {
				$wp_scripts->add( $_handle[0], $src, $deps, $ver );
			}

			if ( $in_footer ) {
				$wp_scripts->add_data( $_handle[0], 'group', 1 );
			}
		}

		$wp_scripts->enqueue( $handle );
	}
	// class wp-scripts.php....
	public function print_extra_script( $handle, $echo = true ) {
		...
	}








	*/
}
?>
