<?php

if (class_exists('spxvisualwizardWidget')) {

	class col extends spxvisualwizardWidget {
		
		
		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->name = 'col';
			$this->title = $this->__( 'title-col', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-col', 'spxvisualwizard' );
			$this->category = "Content";
			
			// spanmed and topmed : use for table cassure topmed use to know if cols are the first
			// ex :
			// 3 - 3 - 6 
			// become
			// 6 - 6 topmed=1 margin-top: 0px;
			// 12 topmed=0 margin-top: 15px;
			
			$options = array(
				
				'span' => '1',
				'spanmed' => '12',
				'topmed' => '0',
				
				'bg_type' => 'none',
				'bgcolor' => 'transparent',
				'bgcolor_dark' => 'transparent',
				'bgcolor_light' => 'transparent',
				'bgon' => 'col',
				'bgimage' => '',
				
				'textalign' => 'inherit',
				
				'zdepth' => '0'
			);
			
			$this->default_options = $this->merge_advanced_default_options($options);
			
			$this->add_shortcode();
		}
		
		public function add_shortcode(){
			add_shortcode( 'viw_col', array( $this, 'shortcode_frontend' ) );
		}
		
		public function shortcode_frontend( $atts, $content ){
			$content = do_shortcode($content);
			extract( shortcode_atts( $this->default_options, $atts ) );

			$class  = 'vwi_col';
			$class2  = 'vwi_col-wrapper';
			
			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$styleadv = $oaof["style"];
			$idadv = $oaof["id"];
			$class .= $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */
			
			switch ($span) {
				case "1":
				case "2":
				case "3":
				case "2":
				case "4":
				case "5":
				case "6":
				case "7":
				case "8":
				case "9":
				case "10":
				case "11":
				case "12":
					$class  .= ' vwi_lrg-'.$span;
					//$class  .= ' vwi_col-flex-lg-'.$span;
					
				break;
			}
			
			switch ($spanmed) {
				case "1":
				case "2":
				case "3":
				case "2":
				case "4":
				case "5":
				case "6":
				case "7":
				case "8":
				case "9":
				case "10":
				case "11":
				case "12":
					
					$class  .= ' vwi_med-'.$spanmed;
					if ($topmed=="1"){
						$class  .= ' vwi_med-coltop';
					} else {
						$class  .= ' vwi_med-colnotontop';
					}
				break;
			}
			
			
			
			
			switch ($zdepth) {
				case "1":
				case "1-half":
				case "2":
				case "3":
				case "4":
				case "5":
				case "6":
					if ($bgon=="col"){
						$class  .= ' vwi_z-depth-'.$zdepth;
					}else{
						$class2  .= ' vwi_z-depth-'.$zdepth;
					}
					
				break;
			}
			
			// plutot l'intérieur en bg color http://codepen.io/Arnique/pen/EjGGEK et non la col elle meme a cause du padding (a cogiter)
			$cssstyle = 'style="';
			if ($bgon=="col" && $bg_type=="color"){
				if ($bgcolor!='')
					$cssstyle .= 'background-color:'.$bgcolor.';';
			} else if ($bgon=="col" && $bg_type=="photo") {
				$plxMotor =  plxMotor::getInstance();
				$basepath_image = isset($plxMotor->aConf['medias']) ? $plxMotor->aConf['medias'] : $plxMotor->aConf['images'];
				$cssstyle .= 'background-image: url(\''.PLX_ROOT.$basepath_image.$bgimage.'\') ;';
			}
			$cssstyle .= 'text-align:'.$textalign.';';
			$cssstyle .= $styleadv;
			$cssstyle .= '"';
			
			$cssstyle2 = 'style="';
			if ($bgon=="colwrapper" && $bg_type=="color"){
				$cssstyle2 .= 'background-color:'.$bgcolor.';';
			} else if ($bgon=="colwrapper" && $bg_type=="photo") {
				$plxMotor =  plxMotor::getInstance();
				$basepath_image = isset($plxMotor->aConf['medias']) ? $plxMotor->aConf['medias'] : $plxMotor->aConf['images'];
				$cssstyle2 .= 'background-image: url(\''.PLX_ROOT.$basepath_image.$bgimage.'\') ;';
			}
			$cssstyle2 .= '"';
			
			$html ='';
			
			$html .= '<div '.$idadv.' '.$cssstyle.' class="'.$class.'" '.$extra.' ><div '.$cssstyle2.' class="'.$class2.'" >'.$content.'</div></div>';
			
			//$html = '<div '.$cssstyle.' class="'.$class.'">'.$content.'</div>';
			
			
			return $html;
		}
		
		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );
			
			# toggle bg type
			$atoggle_bg_type = array (
				'none' => array (),
				'color' => array (
					'field' => array (
						'bgcolor',
						'bgon'
					),
				),
				'photo' => array (
					'field' => array (
						'bgimage',
						'bgon'
					),
				),
			);
			
			$ajsontoggle_bg_type = htmlspecialchars(json_encode($atoggle_bg_type), ENT_QUOTES, 'UTF-8');
			
			$options = array(
				
				array(
						'param_name' => 'span',
						'title' => '',
						'desc' => '',
						'type' => 'hidden',
						'value' => $span,
					),
				
				array(
					'title' => $this->__( 'Display', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),
				
				array(
					'param_name' => 'textalign',
					'title' => $this->__( 'Text align', 'spxvisualwizard' ),
					'desc' => $this->__( 'The alignement of the text, button, icon...', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $textalign,
					'data' => array(
						'inherit' =>  $this->__( 'inherit', 'spxvisualwizard' ),
						'left' =>  $this->__( 'left', 'spxvisualwizard' ),
						'right' => $this->__( 'right', 'spxvisualwizard' ),
						'center' => $this->__( 'center', 'spxvisualwizard' ),
						'justify' =>  $this->__( 'justify', 'dnd-sustifyhortcodes' ),
					),
				),
				
				array(
					'param_name' => 'zdepth',
					'title' => $this->__( 'z-depth', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $zdepth,
					'data' => array(
						'0' => $this->__( '0', 'spxvisualwizard' ),
						'1' => $this->__( '1', 'spxvisualwizard' ),
						'1-half' => $this->__( '1-half', 'spxvisualwizard' ),
						'2' => $this->__( '2', 'spxvisualwizard' ),
						'3' => $this->__( '3', 'spxvisualwizard' ),
						'4' => $this->__( '4', 'spxvisualwizard' ),
						'5' => $this->__( '5', 'spxvisualwizard' )
						
					),
				),	
				
				array(
					'title' => $this->__( 'Background', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),
				
				array(
					'param_name' => 'bg_type',
					'title' => $this->__( 'background type', 'spxvisualwizard' ),
					'desc' => $this->__( 'background type', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $bg_type,
					'innerextra' => ' data-toggle="'.$ajsontoggle_bg_type .'" ',
					'class' => 'viw_ui-needtoggle',
					'data' => array(
						'none' =>  $this->__( 'None', 'spxvisualwizard' ),
						'color' =>  $this->__( 'Color', 'spxvisualwizard' ),
						'photo' => $this->__( 'Photo', 'spxvisualwizard' )
					
					),
				),
				
				array(
						'param_name' => 'bgcolor',
						'title' => $this->__( 'Background color', 'spxvisualwizard' ),
						'desc' => '',
						'type' => 'colordefault',
						'selected' => $bgcolor,
					),
					
				array(
						'param_name' => 'bgimage',
						'title' => $this->__( 'Background image', 'spxvisualwizard' ),
						'desc' => $this->__( 'The bg image of the col.', 'spxvisualwizard' ),
						'type' => 'image',
						'value' => $bgimage,
					),
					
					
				array(
					'param_name' => 'bgon',
					'title' => $this->__( 'Background color on', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $bgon,
					'data' => array(
						'col' =>  $this->__( 'Col with gutter include', 'spxvisualwizard' ),
						'colwrapper' =>  $this->__( 'Col wrapper only', 'spxvisualwizard' ),
					),
				),	
					
					
			);
			
			return $this->get_options($options);
		}
	}
}
?>