<?php
if (class_exists('spxvisualwizardWidget')) {

	class viwcontact extends spxvisualwizardWidget {


		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->name = 'contact';
			$this->title = $this->__( 'title-contact', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-contact', 'spxvisualwizard' );
			$this->category = "Group";
			$this->dependencies = array(

			);

			$options = array(

				'content' => '[viw_button

				color="#42A5F5"
				color_dark="#128ef2"
				color_light="#72bcf8"
				txtcolor="#ffffff"
				txtcolor_dark="#e6e6e6"
				txtcolor_light="#ffffff"
				shape="square"
				style="flat"
				hover="default"
				]Send[/viw_button]',




				'txtcolor' => '#ffffff',
				'txtcolor_dark' => '#e6e6e6',
				'txtcolor_light' => '#ffffff',

				'alertcolor' => '#d0181e',
				'alertcolor_dark' => '#d0181e',
				'alertcolor_light' => '#d0181e',


				'color' => '#42a5f5',
				'color_dark' => '#42a5f5',
				'color_light' => '#42a5f5',

				'bttxtcolor' => '#ffffff',
				'bttxtcolor_dark' => '#e6e6e6',
				'bttxtcolor_light' => '#ffffff',



				'textalign' => 'inherit',

				'level' => 'h3',
				'mailto_email' => '',

				'namefield' => '1',
				'subjectfield' => '1',
				'emailfield' => '1',
				'phonefield' => '1',

			);

			$this->default_options = $this->merge_advanced_default_options($options);

			$this->add_shortcode();
		}

		public function add_shortcode(){
			add_shortcode( 'viw_contact', array( $this, 'shortcode_frontend' ) );
		}



		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$options = array(

				array(
					'param_name' => 'mailto_email',
					'title' => $this->__( 'mailto email', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'text',
					'value' => $mailto_email,
				),

				array(
					'title' => $this->__( 'Structure', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),

				array(
					'param_name' => 'namefield',
					'title' => $this->__( 'Name Field', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $namefield,
					'data' => array(
						'1' => $this->__( 'Show', 'spxvisualwizard' ),
						'0' => $this->__( 'Hide', 'spxvisualwizard' ),
					),
				),

				array(
					'param_name' => 'subjectfield',
					'title' => $this->__( 'Subject Field', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $subjectfield,
					'data' => array(
						'1' => $this->__( 'Show', 'spxvisualwizard' ),
						'0' => $this->__( 'Hide', 'spxvisualwizard' ),
					),
				),

				array(
					'param_name' => 'emailfield',
					'title' => $this->__( 'Email Field', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $emailfield,
					'data' => array(
						'1' => $this->__( 'Show', 'spxvisualwizard' ),
						'0' => $this->__( 'Hide', 'spxvisualwizard' ),
					),
				),

				array(
					'param_name' => 'phonefield',
					'title' => $this->__( 'Phone Field', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $phonefield,
					'data' => array(
						'1' => $this->__( 'Show', 'spxvisualwizard' ),
						'0' => $this->__( 'Hide', 'spxvisualwizard' ),
					),
				),

				array(
					'title' => $this->__( 'Design', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),

				array(
						'param_name' => 'txtcolor',
						'title' => $this->__( 'Text color', 'spxvisualwizard' ),
						'desc' => $this->__( 'The text color.', 'spxvisualwizard' ),
						'type' => 'colordefault',
						'selected' => $txtcolor,
				),

				array(
						'param_name' => 'alertcolor',
						'title' => $this->__( 'Text alert color', 'spxvisualwizard' ),
						'desc' => $this->__( 'The color of the alert.', 'spxvisualwizard' ),
						'type' => 'colornodefault',
						'selected' => $alertcolor,
				),

				array(
						'param_name' => 'color',
						'title' => $this->__( 'Background button color', 'spxvisualwizard' ),
						'desc' => $this->__( 'The color of the background of the button.', 'spxvisualwizard' ),
						'type' => 'colornodefault',
						'selected' => $color,
				),

				array(
						'param_name' => 'bttxtcolor',
						'title' => $this->__( 'Text button color', 'spxvisualwizard' ),
						'desc' => $this->__( 'The color of the text button.', 'spxvisualwizard' ),
						'type' => 'colornodefault',
						'selected' => $bttxtcolor,
				),

			);


			return $this->get_options($options);
		}

		public function contact_checkForm( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$info = '';

			$error_empty = $this->__( 'Error Empty', 'spxvisualwizard' );
			$error_noemail = $this->__( 'Error no email', 'spxvisualwizard' );
			$error_sendemail = $this->__( 'Error send mail', 'spxvisualwizard' );

			$fielderror = "";

			// $email = "je-evrard@neuf.fr";
			$email = $mailto_email;
			$email_cc = "";
			$email_bcc = "";

			$success = $this->__( 'Email post success', 'spxvisualwizard' );

			$out = false;

			if(!empty($_POST["viw_contact-control"])) {
				$out = array();
				$berror = false;
				$bsuccess = false;

				$required_fields = array ();
				if ($namefield=="1") array_push($required_fields, "viw_contact-name");
				if ($subjectfield=="1") array_push($required_fields, "viw_contact-subject");
				if ($emailfield=="1") array_push($required_fields, "viw_contact-email");
				if ($phonefield=="1") array_push($required_fields, "viw_contact-phone");

				array_push($required_fields, "viw_contact-message");

				$form_data = array();
				foreach ( $_POST as $field => $value ) {
					$form_data[$field] = strip_tags( $value );
				}

				foreach ( $required_fields as $required_field ) {

					$value = trim( $form_data[$required_field] );
					if ( empty( $value ) ) {
						$berror = true;
						$result = $error_empty;
						$fielderror=$required_field;
						break;
					}
				}

				if ($emailfield=="1"){
					if (! filter_var($form_data['viw_contact-email'], FILTER_VALIDATE_EMAIL)) {
						$berror = true;
						$result = $error_noemail;
						$fielderror='viw_contact-email';
					}
				}

				if ( $berror == false ) {

					$email_subject = $form_data['viw_contact-subject'];
					if ($email_subject=="") $email_subject=$_SERVER["HTTP_HOST"];
					$contact_name = $form_data['viw_contact-name'];
					if ($contact_name=="") $contact_name= $this->contact_get_the_ip();
					$contact_email = $form_data['viw_contact-email'];
					if ($contact_email=="") $contact_email= "Unknown";

					// get the message from the form and add the IP address of the user below it
					$email_message = $form_data['viw_contact-message'] . "\n\nIP: " . $this->contact_get_the_ip();

					if($this->contact_send_mail($contact_name,$contact_email,$email,$email_subject,$email_message,'text',$email_cc,$email_bcc)) {
						// and set the result text to the shortcode attribute named 'success'
						$result = $success;
						// ...and switch the $sent variable to TRUE
						$sent = true;
					}else{
						$result = $error_sendemail;
						$berror = true;
					}

				}

				if ( $result != "" ) {
					if ($berror == true){
						$info = '<div class="viw_contact-alert-error">' . $result . '</div>';
					}else{
						$info = '<div class="viw_contact-alert-success">' . $result . '</div>';
						$bsuccess = true;
					}
				}

				$out["info"]=$info;
				$out["error"]=$berror;
				$out["success"]=$bsuccess;
				$out["fielderror"]=$fielderror;
			}

			return $out;
		}


		public function contact_get_the_ip() {
			if (isset($_SERVER["HTTP_X_FORWARDED_FOR"])) {
				return $_SERVER["HTTP_X_FORWARDED_FOR"];
			}
			elseif (isset($_SERVER["HTTP_CLIENT_IP"])) {
				return $_SERVER["HTTP_CLIENT_IP"];
			}
			else {
				return $_SERVER["REMOTE_ADDR"];
			}
		}

		public function contact_send_mail($name, $from, $to, $subject, $body, $contentType="text", $cc=false, $bcc=false) {

			if(is_array($to))
				$to = implode(', ', $to);
			if(is_array($cc))
				$cc = implode(', ', $cc);
			if(is_array($bcc))
				$bcc = implode(', ', $bcc);


			$headers  = "From: ".$name." <".$from.">\r\n";
			$headers .= "Reply-To: ".$from."\r\n";
			$headers .= 'MIME-Version: 1.0'."\r\n";
			// Content-Type
			if($contentType == 'html')
				$headers .= 'Content-type: text/html; charset="utf-8"'."\r\n";
			else
				$headers .= 'Content-type: text/plain; charset="utf-8"'."\r\n";

			$headers .= 'Content-transfer-encoding: 8bit'."\r\n";
			$headers .= 'Date: '.date("D, j M Y G:i:s O")."\r\n"; // Sat, 7 Jun 2001 12:35:58 -0700

			if($cc != "")
				$headers .= 'Cc: '.$cc."\r\n";
			if($bcc != "")
				$headers .= 'Bcc: '.$bcc."\r\n";

			return mail($to, $subject, $body, $headers);
		}

		public function template_wireframe_formatter() {
			?>
			<script type="text/javascript">
				var tmpcontactformatter = {
						"contact_style": function (uniqid, alertcolor ) {
							var scopecss = '<style type="text/css" scoped="scoped">';
								scopecss +='.viw_contact-'+uniqid+' .viw_contact-error,.viw_contact-'+uniqid+'.viw_contact-alert-error { color: '+alertcolor+' !important; }';
								scopecss +='.viw_contact-'+uniqid+' input.viw_contact-field-error, .viw_contact-'+uniqid+' textarea.viw_contact-field-error { border-color: '+alertcolor+' !important; }';

							scopecss +='</style>';
							return scopecss;
						},

						"contact_structure": function (uniqid, namefield, subjectfield, emailfield, phonefield){
							var s='';
							if (namefield == '1'){
								s+='<div class="viw_contact-form-group"><label class="viw_contact-label" for="viw_contact-name">Name</label><input type="text" class="viw_contact-name " name="viw_contact-name" value="" placeholder="Your name"></div>';
							}
							if (subjectfield == '1'){
								s+='<div class="viw_contact-form-group"><label class="viw_contact-label" for="viw_contact-subject">Subjet</label><input type="text" class="viw_contact-subject " name="viw_contact-subject" value="" placeholder="Your Subjet"></div>';
							}
							if (emailfield == '1'){
								s+='<div class="viw_contact-form-group"><label class="viw_contact-label" for="viw_contact-email">Email</label><input type="text" class="viw_contact-email " name="viw_contact-email" value="" placeholder="Your email"></div>';
							}
							if (phonefield == '1'){
								s+='<div class="viw_contact-form-group"><label class="viw_contact-label" for="viw_contact-phone">Phone</label><input type="text" class="viw_contact-phone " name="viw_contact-phone" value="" placeholder="Your phone"></div>';
							}
							return s;

						},

				}	;

				Mustache.Formatters = Object.assign(Mustache.Formatters, tmpcontactformatter);
			</script>
			<?php
		}
		public function template_preview() {
			?>

			<script id="id_viw_template_widget_preview_contact" type="x-tmpl-mustache">
				{{{ uniqueid | contact_style : alertcolor }}}

				<div style="color:{{ txtcolor }}" class="viw_contact  viw_contact-{{ uniqueid }}">
					<div id="contactanchor"></div>

						<style type="text/css" scoped="scoped">
								.viw_contact-58db8347cdfdb .viw_contact-error,
								.viw_contact-58db8347cdfdb .viw_contact-alert-error {
									color: #d0181e !important;
								}
								.viw_contact-58db8347cdfdb input.viw_contact-field-error,
								.viw_contact-58db8347cdfdb textarea.viw_contact-field-error {
									border-color: #d0181e !important;
								}

						</style>

						<form class="viw_contact-form-58db8347cdfdb" role="form" method="post" action="#contactanchor" accept-charset="utf-8">

							<input type="hidden" name="viw_contact-control" value="true">

								{{{ uniqid | contact_structure : namefield : subjectfield : emailfield : phonefield }}}

							<div class="viw_contact-form-group">
								<label class="viw_contact-label" for="viw_contact-message">Message</label>

								<textarea class="viw_contact-message " name="viw_contact-message" placeholder="Votre message"></textarea>

							</div>


							<div>

							<style type="text/css" scoped="scoped">

								input.vwi_button.vwi_button-{{ uniqid }} {
									border-color:{{ color_dark }};background-color:{{ color }};
									color:{{ bttxtcolor }};
								}
								input.vwi_button.vwi_button-{{ uniqid }}:hover {
									border-color: {{ color_light }};
									background-color: {{ color_dark }};
								}

								input.vwi_button.vwi_button-{{ uniqid }}.vwi_button-stylebordered {background-color: transparent;}

							</style>

							<input type="submit" disabled="disabled" class="vwi_button vwi_button-{{ uniqid }} vwi_button-txtdisplay-none vwi_button-inlineblock vwi_button-styleflat vwi_button-size2" name="send">

							</div>


						</form>


				</div>

			</script>
			<?php
		}

		public function shortcode_frontend( $atts, $content ){ # why i'm in backend?
			extract( shortcode_atts( $this->default_options, $atts ) );
			foreach(explode(' ','name subject email phone message') as $a) $mypost['viw_contact-'.$a]='';#fix init
			/*$content = stripslashes(rawurldecode($content));
			$content = str_replace("&#34;", '"', $content);
			$content = do_shortcode($content);*/
			$mypost = array_merge($mypost, $_POST);#fix init

			$html = '';
			$fielderror = '';
			$check = $this->contact_checkForm( $atts );
			//echo ("check");
			//print_r($check);


			/*
			la logique est la suivante :
			si $out vide ne fait rien
			sinon
				$out["info"] -> display
				fielderror -> si != '' -> field impacté par l'erreur
					fielderror= "viw_contact-name" -> affiche viw_contact-error du group concerné
					exception
					fielderror= "viw_contact-email"


			*/

			$class  = 'viw_contact';

			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$styleadv = $oaof["style"];
			$styleadv2 = $oaof["style2"];
			$idadv = $oaof["id"];
			$classadv = $class  .= $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */

			$cssstyle = 'style="';
			if ($txtcolor !='') $cssstyle .= 'color:'.$txtcolor.';';
			$cssstyle .= $styleadv;
			$cssstyle .= '"';

			$formuniqid = uniqid();
			$html .= '
			<div '.$cssstyle.$idadv.' class="'.$class.' viw_contact-'.$formuniqid.'" '.$extra.'>
				<div id="contactanchor" ></div>
				';
				if ($check) {
					$html.=$check["info"];
					$fielderror = $check["fielderror"];
				}

				if (!$check or $check["success"]==false){ # Fix : Warning: Trying to access array offset on value of type bool

					$html .= '
					<style type="text/css" scoped="scoped">

							.viw_contact-'.$formuniqid.' .viw_contact-error,
							.viw_contact-'.$formuniqid.' .viw_contact-alert-error {
								color: '.$alertcolor.' !important;
							}
							.viw_contact-'.$formuniqid.' input.viw_contact-field-error,
							.viw_contact-'.$formuniqid.' textarea.viw_contact-field-error {
								border-color: '.$alertcolor.' !important;
							}


					</style>

					<form class="viw_contact-form-'.$formuniqid.'" role="form" method="post" action="#contactanchor" accept-charset="utf-8">

						<input type="hidden" name="viw_contact-control" value="true" >
						';
						if ($namefield=='1'){
							$html .= '
							<div class="viw_contact-form-group">
								<label class="viw_contact-label" for="viw_contact-name">'.$this->__( 'Name', 'spxvisualwizard' ).'</label>
								';
								$classinputerror = "";
								if ($fielderror=="viw_contact-name"){
									$html .= '
										<span class="viw_contact-error">'.$this->__( 'Please enter your name.', 'spxvisualwizard' ).'</span>
									';
									$classinputerror = "viw_contact-field-error";
								}
								$html .= '
								<input type="text" class="viw_contact-name '.$classinputerror.'" name="viw_contact-name" value="'.$mypost["viw_contact-name"].'" placeholder="'.$this->__( 'Your name', 'spxvisualwizard' ).'" >
							</div>
							';
						}
						if ($subjectfield=='1'){
							$html .= '
							<div class="viw_contact-form-group">
								<label class="viw_contact-label" for="viw_contact-subject">'.$this->__( 'Subject', 'spxvisualwizard' ).'</label>
								';
								$classinputerror = "";
								if ($fielderror=="viw_contact-subject"){
									$html .= '
									<span class="viw_contact-error">'.$this->__( 'Please enter your subject', 'spxvisualwizard' ).'</span>
									';
									$classinputerror = "viw_contact-field-error";
								}
								$html .= '
								<input type="text" class="viw_contact-subject '.$classinputerror.'" name="viw_contact-subject" value="'.$mypost["viw_contact-subject"].'" placeholder="'.$this->__( 'Subject', 'spxvisualwizard' ).'" >
							</div>
							';
						}
						if ($emailfield=='1'){
							$html .= '
							<div class="viw_contact-form-group">
								<label class="viw_contact-label" for="viw_contact-email">'.$this->__( 'Email', 'spxvisualwizard' ).'</label>
								';
								$classinputerror = "";
								if ($fielderror=="viw_contact-email"){
									$html .= '
									<span class="viw_contact-error">'.$this->__( 'Please enter your email', 'spxvisualwizard' ).'</span>
									';
									$classinputerror = "viw_contact-field-error";
								}
								$html .= '
								<input type="text" class="viw_contact-email '.$classinputerror.'" name="viw_contact-email" value="'.$mypost["viw_contact-email"].'" placeholder="'.$this->__( 'Your email', 'spxvisualwizard' ).'" >
							</div>
							';
						}
						if ($phonefield=='1'){
							$html .= '
							<div class="viw_contact-form-group">
								<label class="viw_contact-label" for="viw_contact-phone">'.$this->__( 'Phone', 'spxvisualwizard' ).'</label>
								';
								$classinputerror = "";
								if ($fielderror=="viw_contact-phone"){
									$html .= '
									<span class="viw_contact-error">'.$this->__( 'Please enter your phone', 'spxvisualwizard' ).'</span>
									';
									$classinputerror = "viw_contact-field-error";
								}
								$html .= '
								<input type="text" class="viw_contact-phone '.$classinputerror.'" name="viw_contact-phone" value="'.$mypost["viw_contact-phone"].'" placeholder="'.$this->__( 'Your phone', 'spxvisualwizard' ).'" >
							</div>
							';
						}
						$html .= '
						<div class="viw_contact-form-group">
							<label class="viw_contact-label" for="viw_contact-message">'.$this->__( 'Message', 'spxvisualwizard' ).'</label>
							';
							$classinputerror = "";
							if ($fielderror=="viw_contact-message"){
								$html .= '
								<span class="viw_contact-error">'.$this->__( 'Please enter your message', 'spxvisualwizard' ).'</span>
								';
								$classinputerror = "viw_contact-field-error";
							}
							$html .= '
							<textarea class="viw_contact-message '.$classinputerror.'" name="viw_contact-message" placeholder="'.$this->__( 'Your message', 'spxvisualwizard' ).'">'.$mypost["viw_contact-message"].'</textarea>

						</div>

						';

						$uniqid = uniqid();
						$html .= '
						<div>

						<style type="text/css" scoped="scoped">


							input.vwi_button.vwi_button-'.$uniqid.' {
								border-color:'.$color_dark.';background-color:'.$color.';
								color:'.$bttxtcolor.';
							}
							input.vwi_button.vwi_button-'.$uniqid.':hover {
								border-color: '.$color_light.';
								background-color: '.$color_dark.';
							}

							input.vwi_button.vwi_button-'.$uniqid.'.vwi_button-stylebordered {background-color: transparent;}

						</style>

						<input type="submit" class="vwi_button vwi_button-'.$uniqid.' vwi_button-txtdisplay-none vwi_button-inlineblock vwi_button-styleflat vwi_button-size2" name="send" />

						</div>


					</form>
					';

				}

				$html .= '

			</div>';

			return $html;
		}


	}
}
?>