<?php

if (class_exists('spxvisualwizardWidget')) {

	class divider extends spxvisualwizardWidget {

		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->name = 'divider';
			$this->title = $this->__( 'title-divider', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-divider', 'spxvisualwizard' );
			$this->category = "Content";

			$options = array(

				'color' => '#f5f5f5',
				'color_dark' => '#eeeeee',
				'color_light' => '#fafafa',


				'item_alignement' => 'middlecenter',
				'style' => 'border',
				'item_height' => '10',
				'item_width' => '80',
				'item_style' => '1',
				'container_height' => '40',

				'icon_icon' => 'fa fa-chevron-down',
				'icon_alignement' => 'icon_middlecenter',
				'icon_size' 	=> '3',
				'icon_zdepth' => '3',
				'icon_shape' => 'circle',
				'icon_style' => 'flat',

			);

			$this->default_options = $this->merge_advanced_default_options($options);

			$this->add_shortcode();
		}

		public function add_shortcode(){
			add_shortcode( 'viw_divider', array( $this, 'shortcode_frontend' ) );
		}



		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$options = array(

				array(
					'param_name' => 'container_height',
					'title' => $this->__( 'Container height', 'spxvisualwizard' ),
					'desc' => $this->__( 'Height of the container.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $container_height,
					'data' => array(
						'10' =>  $this->__( '10px', 'spxvisualwizard' ),
						'20' =>  $this->__( '20px', 'spxvisualwizard' ),
						'30' =>  $this->__( '30px', 'spxvisualwizard' ),
						'40' =>  $this->__( '40px', 'spxvisualwizard' ),
						'50' =>  $this->__( '50px', 'spxvisualwizard' ),
						'60' =>  $this->__( '60px', 'spxvisualwizard' ),
						'70' =>  $this->__( '70px', 'spxvisualwizard' ),
						'80' =>  $this->__( '80px', 'spxvisualwizard' ),
						'90' =>  $this->__( '90px', 'spxvisualwizard' ),
						'100' =>  $this->__( '100px', 'spxvisualwizard' ),

					),
				),

				array(
					'param_name' => 'item_alignement',
					'title' => $this->__( 'Item alignement', 'spxvisualwizard' ),
					'desc' => $this->__( 'The alignement of the item in the container', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $item_alignement,
					'data' => array(
						'topleft' =>  $this->__( 'topleft', 'spxvisualwizard' ),
						'topright' => $this->__( 'topright', 'spxvisualwizard' ),
						'topcenter' => $this->__( 'topcenter', 'spxvisualwizard' ),
						'middleleft' =>  $this->__( 'middleleft', 'spxvisualwizard' ),
						'middleright' => $this->__( 'middleright', 'spxvisualwizard' ),
						'middlecenter' => $this->__( 'middlecenter', 'spxvisualwizard' ),
						'bottomleft' =>  $this->__( 'bottomleft', 'spxvisualwizard' ),
						'bottomright' => $this->__( 'bottomright', 'spxvisualwizard' ),
						'bottomcenter' => $this->__( 'bottomcenter', 'spxvisualwizard' ),

					),
				),

				array(
					'param_name' => 'item_style',
					'title' => $this->__( 'Item style', 'spxvisualwizard' ),
					'desc' => $this->__( 'The style of the divider.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $item_style,
					'data' => array(
						'color' =>  $this->__( 'color only', 'spxvisualwizard' ),
						'1' =>  $this->__( 'pattern dots', 'spxvisualwizard' ),
						'2' => $this->__( 'pattern white', 'spxvisualwizard' ),
						'3' => $this->__( 'pattern stripes', 'spxvisualwizard' ),
						'4' => $this->__( 'pattern linen', 'spxvisualwizard' )

					),
				),
				/*
				array(
					'param_name' => 'color',
					'title' => $this->__( 'Color', 'spxvisualwizard' ),
					'desc' => $this->__( 'The color of the divider.', 'spxvisualwizard' ),
					'type' => 'select2',
					'selected' => $color,
					'data' => array(
						'#ffebee' =>  'red lighten-5',
						'#ffcdd2' =>  'red lighten-4',
						'grey' => $this->__( 'grey', 'spxvisualwizard' ),
						'fdeaeb' => $this->__( 'red lighten-5', 'spxvisualwizard' )

					),
					'datastyle' => array(
						'#ffebee'  => 'background-color:#ffebee;',
						'#ffcdd2' => 'background-color:#ffcdd2;',
						'fdeaeb' => 'background-color:#eceff1;'

					),

					//$params["style"].=" background-color:'#eceff1;'";
				),
				*/

				array(
					'param_name' => 'color',
					'title' => $this->__( 'Color', 'spxvisualwizard' ),
					'desc' => $this->__( 'The color of the divider.', 'spxvisualwizard' ),
					'type' => 'colornodefault',
					'selected' => $color,
				),



				array(
					'param_name' => 'item_height',
					'title' => $this->__( 'Border width', 'spxvisualwizard' ),
					'desc' => $this->__( 'The border width of the divider.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $item_height,
					'data' => array(
						'0' =>  $this->__( '0px', 'spxvisualwizard' ),
						'1' =>  $this->__( '1px', 'spxvisualwizard' ),
						'2' =>  $this->__( '2px', 'spxvisualwizard' ),
						'3' =>  $this->__( '3px', 'spxvisualwizard' ),
						'4' =>  $this->__( '4px', 'spxvisualwizard' ),
						'5' =>  $this->__( '5px', 'spxvisualwizard' ),
						'6' =>  $this->__( '6px', 'spxvisualwizard' ),
						'7' =>  $this->__( '7px', 'spxvisualwizard' ),
						'8' =>  $this->__( '8px', 'spxvisualwizard' ),
						'9' =>  $this->__( '9px', 'spxvisualwizard' ),
						'10' =>  $this->__( '10px', 'spxvisualwizard' ),

					),
				),

				array(
					'param_name' => 'item_width',
					'title' => $this->__( 'Widget width', 'spxvisualwizard' ),
					'desc' => $this->__( 'The width of the divider.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $item_width,
					'data' => array(
						'100' => $this->__( '100%', 'spxvisualwizard' ),
						'90' =>  $this->__( '90%', 'spxvisualwizard' ),
						'80' =>  $this->__( '80%', 'spxvisualwizard' ),
						'70' =>  $this->__( '70%', 'spxvisualwizard' ),
						'60' =>  $this->__( '60%', 'spxvisualwizard' ),
						'50' =>  $this->__( '50%', 'spxvisualwizard' ),
						'40' =>  $this->__( '40%', 'spxvisualwizard' ),
						'30' =>  $this->__( '30%', 'spxvisualwizard' ),
						'20' =>  $this->__( '20%', 'spxvisualwizard' ),
						'10' =>  $this->__( '10%', 'spxvisualwizard' ),

					),
				),

				array(
					'param_name' => 'icon_icon',
					'title' => $this->__( 'Icon', 'spxvisualwizard' ),
					'desc' => $this->__( '', 'spxvisualwizard' ),
					'type' => 'icon',
					'value' => $icon_icon,
				),

				array(
					'param_name' => 'icon_shape',
					'title' => $this->__( 'Shape', 'spxvisualwizard' ),
					'desc' => $this->__( 'The shape of the icon.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $icon_shape,
					'data' => array(
						'square' =>  $this->__( 'shape square', 'spxvisualwizard' ),
						'rounded' => $this->__( 'shape rounded', 'spxvisualwizard' ),
						'circle' => $this->__( 'shape circle', 'spxvisualwizard' )

					),
				),

				array(
					'param_name' => 'icon_style',
					'title' => $this->__( 'Style', 'spxvisualwizard' ),
					'desc' => $this->__( 'The style of the icon.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $icon_style,
					'data' => array(
						'3d' =>  $this->__( 'style 3d', 'spxvisualwizard' ),
						'flat' => $this->__( 'style flat', 'spxvisualwizard' )

					),
				),


				array(
					'param_name' => 'icon_alignement',
					'title' => $this->__( 'Icon alignement', 'spxvisualwizard' ),
					'desc' => $this->__( 'The alignement of the icon.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $icon_alignement,
					'data' => array(

						'icon_middleleft' =>  $this->__( 'left', 'spxvisualwizard' ),
						'icon_middleright' => $this->__( 'right', 'spxvisualwizard' ),
						'icon_middlecenter' => $this->__( 'center', 'spxvisualwizard' ),


					),
				),

				array(
					'param_name' => 'icon_size',
					'title' => $this->__( 'Icon Size', 'spxvisualwizard' ),
					'desc' => $this->__( 'The size of the icon.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $icon_size,
					'data' => array(
						'1' => $this->__( '1', 'spxvisualwizard' ),
						'2' => $this->__( '2', 'spxvisualwizard' ),
						'3' => $this->__( '3', 'spxvisualwizard' ),
						'4' => $this->__( '4', 'spxvisualwizard' ),
						'5' => $this->__( '5', 'spxvisualwizard' ),
						'6' => $this->__( '6', 'spxvisualwizard' )
					),
				),

				array(
					'param_name' => 'icon_zdepth',
					'title' => $this->__( 'Icon zdepth', 'spxvisualwizard' ),
					'desc' => $this->__( 'The z-depth of the icon.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $icon_zdepth,
					'data' => array(
						'1' => $this->__( '1', 'spxvisualwizard' ),
						'2' => $this->__( '2', 'spxvisualwizard' ),
						'3' => $this->__( '3', 'spxvisualwizard' ),
						'4' => $this->__( '4', 'spxvisualwizard' ),
						'5' => $this->__( '5', 'spxvisualwizard' )

					),
				),









			);


			return $this->get_options($options);
		}

			public function shortcode_frontend( $atts, $content ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			/*

			'color' => 'blue',
				'alignement' => 'center',
				'style' => 'border',
				'border_width' => '1',
				'widget_width' => '100%'

			*/


			$classcontainer  = 'vwi_divider-container vwi_flex vwi_flexRow vwi_flexWrap';
			$classitem  = 'vwi_divider-item';

			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$styleadv = $oaof["style"];
			$idadv = $oaof["id"];
			$classcontainer .= $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */

			switch ($item_style) {
				case "1":
				case "2":
				case "3":
				case "4":
					 $classitem  .= ' ufs-style'.$item_style;
				break;
			}

			switch ($item_alignement) {
				case "topleft":
					$classcontainer  .= ' vwi_flexAlignItemsStart vwi_flexJustifyStart';
				break;
				case "topright":
					$classcontainer  .= ' vwi_flexAlignItemsStart vwi_flexJustifyEnd';
				break;
				case "topcenter":
					$classcontainer  .= ' vwi_flexAlignItemsStart vwi_flexJustifyCenter';
				break;
				case "middleleft":
					$classcontainer  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyStart';
				break;
				case "middleright":
					$classcontainer  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyEnd';
				break;
				case "middlecenter":
					$classcontainer  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyCenter';
				break;
				case "bottomleft":
					$classcontainer  .= ' vwi_flexAlignItemsEnd vwi_flexJustifyStart';
				case "bottomright":
					$classcontainer  .= ' vwi_flexAlignItemsEnd vwi_flexJustifyEnd';
				break;
				case "bottomcenter":
					$classcontainer  .= ' vwi_flexAlignItemsEnd vwi_flexJustifyCenter';
				break;
			}

			/*icon */


			$classitem  .= ' vwi_divider-container vwi_flex vwi_flexRow ';
			// $classicon  ='fa fa-chevron-down';
			$classicon  = $icon_icon;
			$iconaddstyle = '';

			switch ($icon_alignement) {
				case "icon_middleleft":
					$classitem  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyStart';
				break;
				case "icon_middleright":
					$classitem  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyEnd';
				break;
				case "icon_middlecenter":
					$classitem  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyCenter';
				break;
			}

			switch ($icon_size) {
				case "1":
				case "2":
				case "3":
				case "4":
				case "5":
				case "6":
					 $classicon  .= ' vwi_icon-size'.$icon_size;
				break;
			}

			switch ($icon_zdepth) {
				case "1":
				case "2":
				case "3":
				case "4":
				case "5":
				case "6":
					 $classicon  .= ' vwi_z-depth-'.$icon_zdepth;
				break;
			}

			switch ($icon_shape) {

				case "square":
				case "rounded":
				case "circle":
					 $classicon  .= ' vwi_icon-shape'.$icon_shape;
				break;
			}

			switch ($icon_style) {
				case "3d":
					$iconaddstyle = ' border-color: '.$bgcolor_light.'; box-shadow: 0 0.25em 0 0 '.$bgcolor_dark.',0 4px 9px rgba(0,0,0,0.75);';
					$classicon  .= ' vwi_icon-style'.$icon_style;
				break;
				case "flat":
					$classicon  .= ' vwi_icon-style'.$icon_style;
				break;
				case "bordered":
					$iconaddstyle = ' border-color: '.$bgcolor.';';
					$classicon  .= ' vwi_icon-style'.$icon_style;
				break;
			}


			$icon = '<i class="'.$classicon.'" style="'.$iconaddstyle.'" ></i>';

			$html = '<div '.$idadv.' class="'.$classcontainer.'" '.$extra.' style="width:100%; height: '.$container_height.'px; '.$styleadv.'" ><span class="'.$classitem.'" style="background-color:'.$color.'; height: '.$item_height.'px; width: '.$item_width.'%" >'.$icon.'</span></div>';

			return $html;
		}

		public function template_preview() {
			?>
				<script id="id_viw_template_widget_preview_divider" type="x-tmpl-mustache">
					<div class="vwi_divider-container vwi_flex vwi_flexRow vwi_flexWrap {{ item_alignement | item_alignement }}" style="width:100%; height: {{ container_height }}px; {{ adv_mc | adv_margin : adv_mun : adv_mt : adv_mb : adv_ml : adv_mr }}">
						<span class="vwi_divider-item ufs-style{{ item_style }} vwi_divider-container vwi_flex vwi_flexRow {{ icon_alignement | icon_alignement }}" style="background-color:{{ color }}; height: {{ item_height }}px; width: {{ item_width }}%">
							<i class="fa {{ icon_icon }} vwi_icon-size{{ icon_size }} vwi_z-depth-1 vwi_icon-shape{{ icon_shape }} vwi_icon-styleflat" style="" ></i>
						</span>
					</div>
				</script>
			<?php
		}


	}

}
?>