<?php

if (class_exists('spxvisualwizardWidget')) {

	class editorhtml extends spxvisualwizardWidget {
		
		
	
		
		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->name = 'editorhtml';
			$this->title = $this->__( 'title-editorhtml', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-editorhtml', 'spxvisualwizard' );
			$this->category = "Content";
			
			$options = array(
				
				'content' => '',
				'class' => ''
				
			);
			
			$this->default_options = $this->merge_advanced_default_options($options);
			
			$this->add_shortcode();
		}
		
		public function add_shortcode(){
			add_shortcode( 'viw_editorhtml', array( $this, 'shortcode_frontend' ) );
		}
		
		public function shortcode_frontend( $atts, $content ){
			$mycontent = stripslashes(rawurldecode($content));
			$mycontent = str_replace("&#34;", '"', $mycontent);
			extract( shortcode_atts( $this->default_options, $atts ) );

			$class  = 'viw_editorhtml';
			
			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$styleadv = $oaof["style2"];
			$idadv = $oaof["id"];
			$class .= $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */
			
			//$html = '<div class="'.$class.'" >'.$mycontent.'</div>';
			$html = '<div '.$idadv.' class="'.$class.'" '.$styleadv.' '.$extra.' >'.$mycontent.'</div>';
			
			return $html;
		}
		
		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );
			
			$options = array(
			
			
			
				array(
					'param_name' => 'content',
					'title' => $this->__( 'Content', 'pt-builder' ),
					'desc' => '',
					'type' => 'texthtml',
					'value' => $content,
				),

			);
			
			
			return $this->get_options($options);
		}
		
		public function template_preview() {
			?>
			<script id="id_viw_template_widget_preview_editorhtml" type="x-tmpl-mustache">
				<div class="vwi_editorhtml" >
				{{{ content2 }}}
				</div>
		
			</script>
			<?php
		}
		
		public function template_wireframe() {
			?>
				<script id="id_viw_template_widget_wireframe_editorhtml" type="x-tmpl-mustache">
				<div class="viw_ui-widget-title-container">
					<div class="viw_ui-widget-icon-container">
						<span class="viw_ui-widget-icon viw_ui-widget-icon-{{ type }}"></span>
					</div>
					{{ type | uppercase }}
				</div>
				</script>
			<?php
		}
		
	}

}
?>