<?php
// http://www.aconvert.com/image/png-to-svg/
// https://la-cascade.io/utiliser-svg/
// https://github.com/jonathantneal/svg4everybody
// http://www.alsacreations.com/tuto/lire/1421-svg-initiation-syntaxe-outils.html
// https://webdesign.tutsplus.com/articles/manipulating-svg-icons-with-simple-css--webdesign-15694
// http://tutsplus.github.io/Styling-Iconic/state/index.html
// https://useiconic.com/
// http://stackoverflow.com/questions/24933430/img-src-svg-changing-the-fill-color
// http://jsfiddle.net/wuSF7/462/
// http://blog.karenmenezes.com/2015/mar/24/styling-svgs-inside-image-tags/
// http://codepen.io/imohkay/pen/vEbpYM
if (class_exists('spxvisualwizardWidget')) {

	class feltpen extends spxvisualwizardWidget {

		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->name = 'feltpen';
			$this->title = $this->__( 'title-feltpen', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-feltpen', 'spxvisualwizard' );
			$this->category = "Content";

			$options = array(
				'display' => 'inline',
				'color' => 'black',
				'shape' => 'arrowdown',
				'size' 	=> '3',
				'opacity' => '100',
				'item_alignement' => 'left',
			);

			$this->default_options = $this->merge_advanced_default_options($options);

			$this->add_shortcode();
		}

		public function add_shortcode(){
			add_shortcode( 'viw_feltpen', array( $this, 'shortcode_frontend' ) );
		}

		public function shortcode_frontend( $atts, $content ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$class  = 'vwi_feltpen ';
			$classcontainer = '';

			$classicon = '';
			$addstyle = '';

			switch ($display) {
				case "inlineblock":
					 $class  .= ' vwi_feltpen-'.$display;
				break;
			}

			switch ($size) {
				case "1":
				case "2":
				case "3":
				case "4":
				case "5":
				case "6":
					 $classicon  .= ' vwi_feltpen-size'.$size;
				break;
			}

			switch ($shape) {
				case "arrowup":
				case "arrowdown":
				case "arrowleft":
				case "arrowright":
				case "cross":

					 $classicon  .= ' vwi_fetpen-shape-'.$shape.'-'.$color;
				break;
			}

			switch ($item_alignement) {

				case "left":
					$classcontainer  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyStart';
				break;
				case "right":
					$classcontainer  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyEnd';
				break;
				case "center":
					$classcontainer  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyCenter';
				break;

			}

			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$styleadv = $oaof["style"];
			$styleadv2 = $oaof["style2"];
			$idadv = $oaof["id"];
			$classadv = $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */
			// $classicon .= 'text-align:'.$textalign.';';
			$sopacity = $opacity/100;
			$cssstyle = 'style="';
			$cssstyle .= 'opacity:'.$sopacity.';';

			// $cssstyle .= 'text-align:'.$item_alignement.';';
			if ($display=="block"){
				$idadvinline = "";
			}else{
				$cssstyle .= $styleadv;
				$classicon .= $classadv;
				$idadvinline = $oaof["id"];
			}
			$cssstyle .= '"';

			$html = '<span '.$cssstyle.' '.$idadvinline.' class="vwi_fetpen '.$classicon.'" '.$extra.' ></span>';
			if ($display=="block"){
				$html ="<div ".$styleadv2." ".$idadv." class='vwi_fetpen-block vwi_flex ".$classcontainer.$classadv."' ".$extra." >".$html."</div>";
			}

			return $html;
		}

		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$options = array(

				array(
					'param_name' => 'display',
					'title' => $this->__( 'Display', 'spxvisualwizard' ),
					'desc' => $this->__( 'The display of the fetpen.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $display,
					'data' => array(
						'inlineblock' => $this->__( 'inlineblock', 'spxvisualwizard' ),
						'block' => $this->__( 'block', 'spxvisualwizard' ),
					),
				),

				array(
					'param_name' => 'item_alignement',
					'title' => $this->__( 'Item alignement', 'spxvisualwizard' ),
					'desc' => $this->__( 'The alignement of the item (only for display block)', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $item_alignement,
					'data' => array(

						'left' =>  $this->__( 'left', 'spxvisualwizard' ),
						'right' => $this->__( 'right', 'spxvisualwizard' ),
						'center' => $this->__( 'center', 'spxvisualwizard' ),


					),
				),

				array(
					'param_name' => 'shape',
					'title' => $this->__( 'Shape', 'spxvisualwizard' ),
					'desc' => $this->__( 'The shape of the feltpen.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $shape,
					'data' => array(
						'arrowup' =>  $this->__( 'arrow up', 'spxvisualwizard' ),
						'arrowdown' => $this->__( 'arrow down', 'spxvisualwizard' ),
						'arrowleft' => $this->__( 'arrow left', 'spxvisualwizard' ),
						'arrowright' => $this->__( 'arrow right', 'spxvisualwizard' ),
						'cross' => $this->__( 'cross', 'spxvisualwizard' )

					),
				),

				array(
					'param_name' => 'color',
					'title' => $this->__( 'Fetpen color', 'spxvisualwizard' ),
					'desc' => $this->__( 'The color of the pen.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $color,
					'data' => array(
						'black' => $this->__( 'black', 'spxvisualwizard' ),
						'white' => $this->__( 'white', 'spxvisualwizard' ),

					),
				),

				array(
					'param_name' => 'size',
					'title' => $this->__( 'Icon Size', 'spxvisualwizard' ),
					'desc' => $this->__( 'The size of the icon.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $size,
					'data' => array(
						'1' => $this->__( '1', 'spxvisualwizard' ),
						'2' => $this->__( '2', 'spxvisualwizard' ),
						'3' => $this->__( '3', 'spxvisualwizard' ),
						'4' => $this->__( '4', 'spxvisualwizard' ),
						'5' => $this->__( '5', 'spxvisualwizard' ),
						'6' => $this->__( '6', 'spxvisualwizard' )
					),
				),

				array(
					'param_name' => 'opacity',
					'title' => $this->__( 'Icon opacity', 'spxvisualwizard' ),
					'desc' => $this->__( 'The opacity of the icon.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $opacity,
					'data' => array(
						'10' => $this->__( '10', 'spxvisualwizard' ),
						'20' => $this->__( '20', 'spxvisualwizard' ),
						'30' => $this->__( '30', 'spxvisualwizard' ),
						'40' => $this->__( '40', 'spxvisualwizard' ),
						'50' => $this->__( '50', 'spxvisualwizard' ),
						'60' => $this->__( '60', 'spxvisualwizard' ),
						'70' => $this->__( '70', 'spxvisualwizard' ),
						'80' => $this->__( '80', 'spxvisualwizard' ),
						'90' => $this->__( '90', 'spxvisualwizard' ),
						'100' => $this->__( '100', 'spxvisualwizard' )
					),
				),





			);


			return $this->get_options($options);
		}

		public function template_preview() {
			?>
			<script id="id_viw_template_widget_preview_feltpen" type="x-tmpl-mustache">
				<div class="vwi_fetpen-block vwi_flex {{ item_alignement | item_alignement }}" style="{{ adv_mc | adv_margin : adv_mun : adv_mt : adv_mb : adv_ml : adv_mr }}" ><span style="opacity:{{ opacity | numtoopacity }};" class="vwi_fetpen  vwi_feltpen-size{{ size }} vwi_fetpen-shape-{{ shape }}-{{ color }}"></span></div>
			</script>
			<?php
		}


	}

}
?>