<?php

if (class_exists('spxvisualwizardWidget')) {

	class image extends spxvisualwizardWidget {

		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->name = 'image';
			$this->title = $this->__( 'title-image', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-image', 'spxvisualwizard' );
			$this->category = "Content";

			$options = array(

				'image' => '',
				'item_width' => '100',
				'item_alignement' => 'middlecenter',
				'zdepth' => '0',
				'shape' => '',
				'border_width' => '0',
				'border_color' => 'transparent',

				'link' => '',
				'link_target' => '_self'

			);

			$this->default_options = $this->merge_advanced_default_options($options);

			$this->add_shortcode();
		}

		public function add_shortcode(){
			add_shortcode( 'viw_image', array( $this, 'shortcode_frontend' ) );
		}



		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$options = array(

				array(
						'param_name' => 'image',
						'title' => $this->__( 'Image', 'spxvisualwizard' ),
						'desc' => $this->__( 'The image.', 'spxvisualwizard' ),
						'type' => 'image',
						'value' => $image,
					),

				array(
					'param_name' => 'shape',
					'title' => $this->__( 'Shape', 'spxvisualwizard' ),
					'desc' => $this->__( 'The shape of the image.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $shape,
					'data' => array(
						'square' =>  $this->__( 'shape square', 'spxvisualwizard' ),
						'rounded' => $this->__( 'shape rounded', 'spxvisualwizard' ),
						'circle' => $this->__( 'shape circle', 'spxvisualwizard' ),
						'perfectcircle' => $this->__( 'shape perfect circle', 'spxvisualwizard' ),
						'perfectsquare' => $this->__( 'shape perfect square', 'spxvisualwizard' ),
						'perfectdsquarew' => $this->__( 'shape rectangle w', 'spxvisualwizard' ),
						'perfectdsquareh' => $this->__( 'shape rectangle h', 'spxvisualwizard' ),

					),
				),

				array(
					'param_name' => 'border_width',
					'title' => $this->__( 'Border width', 'spxvisualwizard' ),
					'desc' => $this->__( 'The border width of the image.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $border_width,
					'data' => array(
						'0' =>  $this->__( 'No border', 'spxvisualwizard' ),
						'1' =>  $this->__( '1px', 'spxvisualwizard' ),
						'2' =>  $this->__( '2px', 'spxvisualwizard' ),
						'3' =>  $this->__( '3px', 'spxvisualwizard' ),
						'4' =>  $this->__( '4px', 'spxvisualwizard' ),
						'5' =>  $this->__( '5px', 'spxvisualwizard' ),
						'6' =>  $this->__( '6px', 'spxvisualwizard' ),
						'7' =>  $this->__( '7px', 'spxvisualwizard' ),
						'8' =>  $this->__( '8px', 'spxvisualwizard' ),
						'9' =>  $this->__( '9px', 'spxvisualwizard' ),
						'10' =>  $this->__( '10px', 'spxvisualwizard' ),

					),
				),

				array(
					'param_name' => 'border_color',
					'title' => $this->__( 'Border color', 'spxvisualwizard' ),
					'desc' => $this->__( 'The color of the border.', 'spxvisualwizard' ),
					'type' => 'colornodefault',
					'selected' => $border_color,
				),

				array(
					'param_name' => 'item_width',
					'title' => $this->__( 'Widget width', 'spxvisualwizard' ),
					'desc' => $this->__( 'The width of the image.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $item_width,
					'data' => array(
						'100' => $this->__( '100%', 'spxvisualwizard' ),
						'90' =>  $this->__( '90%', 'spxvisualwizard' ),
						'80' =>  $this->__( '80%', 'spxvisualwizard' ),
						'70' =>  $this->__( '70%', 'spxvisualwizard' ),
						'60' =>  $this->__( '60%', 'spxvisualwizard' ),
						'50' =>  $this->__( '50%', 'spxvisualwizard' ),
						'40' =>  $this->__( '40%', 'spxvisualwizard' ),
						'30' =>  $this->__( '30%', 'spxvisualwizard' ),
						'20' =>  $this->__( '20%', 'spxvisualwizard' ),
						'10' =>  $this->__( '10%', 'spxvisualwizard' ),

					),
				),

				array(
					'param_name' => 'item_alignement',
					'title' => $this->__( 'Item alignement', 'spxvisualwizard' ),
					'desc' => $this->__( 'The alignement of the item in the container', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $item_alignement,
					'data' => array(

						'middleleft' =>  $this->__( 'middleleft', 'spxvisualwizard' ),
						'middleright' => $this->__( 'middleright', 'spxvisualwizard' ),
						'middlecenter' => $this->__( 'middlecenter', 'spxvisualwizard' ),


					),
				),

				array(
					'param_name' => 'zdepth',
					'title' => $this->__( 'zdepth', 'spxvisualwizard' ),
					'desc' => $this->__( 'The z-depth of the image.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $zdepth,
					'data' => array(
						'0' => $this->__( '0', 'spxvisualwizard' ),
						'1' => $this->__( '1', 'spxvisualwizard' ),
						'2' => $this->__( '2', 'spxvisualwizard' ),
						'3' => $this->__( '3', 'spxvisualwizard' ),
						'4' => $this->__( '4', 'spxvisualwizard' ),
						'5' => $this->__( '5', 'spxvisualwizard' )

					),
				),

				array(
					'title' => $this->__( 'Link', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),

				array(
						'param_name' => 'link',
						'title' => $this->__( 'Link', 'spxvisualwizard' ),
						'desc' => $this->__( 'If no link keep empty', 'spxvisualwizard' ),
						'type' => 'text',
						'value' => $link,
					),

				array(
					'param_name' => 'link_target',
					'title' => $this->__( 'Link target', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $link_target,
					'data' => array(

						'_self' =>  $this->__( 'Same window', 'spxvisualwizard' ),
						'_blank' => $this->__( 'New window', 'spxvisualwizard' ),

					),
				),


			);




			return $this->get_options($options);
		}

		public function shortcode_frontend( $atts, $content ){
			$content = do_shortcode($content);
			extract( shortcode_atts( $this->default_options, $atts ) );

			$classzdepth = '';
			$classcontainer = 'vwi_image vwi_flex ';
			$classitem  = 'vwi_image-item';
			$class = 'vwi_image-item-img' ;

			switch ($shape) {
				case "rounded":
				case "circle":
				case "perfectcircle":
				case "perfectsquare":
				case "perfectdsquarew":
				case "perfectdsquareh":
					 $classitem  .= ' vwi_image-shape'.$shape;
				break;
			}

			switch ($item_alignement) {

				case "middleleft":
					$classcontainer  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyStart';
				break;
				case "middleright":
					$classcontainer  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyEnd';
				break;
				case "middlecenter":
					$classcontainer  .= ' vwi_flexAlignItemsCenter vwi_flexJustifyCenter';
				break;
			}

			switch ($zdepth) {

				case "1":
				case "2":
				case "3":
				case "4":
				case "5":
				case "6":
					 $classzdepth  .= ' vwi_z-depth-'.$zdepth;
				break;
			}

			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$styleadv = $oaof["style2"];
			$idadv = $oaof["id"];
			$classcontainer = $classcontainer.$oaof["class"];
			$blockadv = $styleadv.$idadv;
			$extra = $oaof["extra"];
			/* end add advanced option */

			$plxMotor =  plxMotor::getInstance();
			$basepath_image = isset($plxMotor->aConf['medias']) ? $plxMotor->aConf['medias'] : $plxMotor->aConf['images'];

			$slink='';
			if ($link != '') $slink=' href="'.$link.'" target="'.$link_target.'" ';

			$html = '<div '.$blockadv.' class="'.$classcontainer.'" '.$extra.' >';

				$cssstyle = 'style="';
					$cssstyle .= 'border-width: '.$border_width.'px ;';
					$cssstyle .= 'border-color: '.$border_color.' ;';
					if ($shape == "perfectcircle" || $shape == "perfectsquare" || $shape == "perfectdsquarew" || $shape == "perfectdsquareh"){
						$cssstyle .= 'background-image: url(\''.PLX_ROOT.$basepath_image.$image.'\') ;';
						$cssstyle .= '"';
						$html .= '<div class="'.$classitem.'" style="width: '.$item_width.'%;" >';
							if ($link!=''){
								$html .= '<a '.$slink.' >';
							}
							$html .= '<div '.$cssstyle.' class="'.$class.$classzdepth.'" ></div>';
							if ($link!=''){
								$html .= '</a>';
							}
						$html .= '</div>';
					}else{
						$cssstyle .= '"';
						$html .= '<div class="'.$classitem.'" style="width: '.$item_width.'%;" > ';
							if ($link!=''){
								$html .= '<a '.$slink.' >';
							}
							$html .= '<img '.$cssstyle.' class="'.$class.$classzdepth.'" src="'.PLX_ROOT.$basepath_image.$image.'" alt="" >';
							if ($link!=''){
								$html .= '</a>';
							}
						$html .= '</div>';

					}

			$html .= '</div>';

			return $html;
		}

		public function template_wireframe_formatter() {
			?>
			<script type="text/javascript">
				var tmpimageformatter = {
						"image_structure": function (image, shape, border_width, border_color, zdepth) {
							var s = '';
							var pathimg = VIWPROP.root_basepath_image+image;
							if (shape == "perfectcircle" || shape == "perfectsquare" || shape == "perfectdsquarew" || shape == "perfectdsquareh"){
								s+='<div style="border-width:'+border_width+'px ;border-color: '+border_color+'; background-image: url(\''+pathimg+'\') ;" class="vwi_image-item-img vwi_z-depth-'+zdepth+'" >';

							}else{
								s+='<img style="border-width:'+border_width+'px ;border-color: '+border_color+';" class="vwi_image-item-img vwi_z-depth-'+zdepth+'" src="'+pathimg+'" alt="">';
							}
							return s;
						},

				};

				Mustache.Formatters = Object.assign(Mustache.Formatters, tmpimageformatter);
			</script>
			<?php
		}

		public function template_preview() {
			?>
				<script id="id_viw_template_widget_preview_image" type="x-tmpl-mustache">
					<div class="vwi_image vwi_flex  {{ item_alignement | item_alignement }}" style="{{ adv_mc | adv_margin : adv_mun : adv_mt : adv_mb : adv_ml : adv_mr }}" >
						<div class="vwi_image-item vwi_image-shape{{ shape }}" style="width: {{ item_width }}%;">
							{{{ image | image_structure : shape : border_width : border_color : zdepth }}}
						</div>
					</div>
				</script>
			<?php
		}

		public function template_wireframe() {
			?>
				<script id="id_viw_template_widget_wireframe_image" type="x-tmpl-mustache">
				<div class="viw_ui-widget-title-container">
					<div style="width:100%;">
						<img
						style="
						border: 2px solid white;
						display: block;
						max-width:100%;
						max-height:40px;
						width: auto !important;
						height: auto!important;
						margin: 0 auto !important;
						text-align:center;
						margin-left: auto!important;
						margin-right: auto!important;
						"
						class="vwi_image-item-img" src="{{ image | imgpath }}" alt="">


					</div>

				</div>

				</script>
			<?php
		}


	}

}
?>