<?php

/**
 * plxlastart - widget to display your last articles
 *
 *
 * @version	2.0
 * @author	start by cfdev (Cyril Frausti) - www.cfdev.fr && continue by je-evrard - www.justeasy.org
 **/

if (class_exists('spxvisualwizardWidget')) {

	class plxlastart extends spxvisualwizardWidget {

		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @author	cfdev
		 **/
		public $lang; 
		 
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->lang = $default_lang;

			$this->name = 'plxlastart';
			$this->title = $this->__( 'title-plxlastart', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-plxlastart', 'spxvisualwizard' );
			$this->category = "Pluxml";

			$options = array(
				'catid' => '',
				'artsnum' => '3',
				'content' => '',
				'colsnum' => 'vwi_lrg-4',
				'bimage' => '1',
				'imageratio' => 'default',
				'bdate' => '1',
				'breadmore' => '1',
				'btitle' => '1',
				'titlelevel' => 'h3',
			);

			$this->default_options = $this->merge_advanced_default_options($options);

			$this->add_shortcode();
		}


		public function add_shortcode(){
			add_shortcode( 'viw_plxlastart', array( $this, 'shortcode_frontend' ) );
		}


		public function shortcode_frontend( $atts, $content ){

			extract( shortcode_atts( $this->default_options, $atts ) );

			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$styleadv = $oaof["style"];
			$styleadv2 = $oaof["style2"];
			$idadv = $oaof["id"];
			$classadv = $class = $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */


			$class  = 'vwi_plxlastart';

			$plxMotor = plxMotor::getInstance();
			$plxShow= plxShow::getInstance();
			$plxGlob_arts = clone $plxMotor->plxGlob_arts;

			# Get global var
			$widget_path = VIW_URL.'/widgets/widgets/plxlastart/';

			ob_start();
			$plxShow->racine();
			$racine_path = ob_get_clean();

			# Number of article
			$art_nb = $artsnum;

			$html = '<div '.$idadv.$styleadv2.' class="viw_plxlasart '.$classadv.'" '.$extra.' > ';

			# $motif =
			if($catid==''){
				$motif = '/^[0-9]{4}.(?:[0-9]|home|,)*(?:'.$plxMotor->activeCats.'|home)(?:[0-9]|home|,)*.[0-9]{3}.[0-9]{12}.[a-z0-9-]+.xml$/';
			} else {
				$motif = '/^[0-9]{4}.((?:[0-9]|home|,)*(?:'.str_pad($catid,3,'0',STR_PAD_LEFT).')(?:[0-9]|home|,)*).[0-9]{3}.[0-9]{12}.[a-z0-9-]+.xml$/';
			}


			if($files = $plxGlob_arts->query($motif,'art','rsort',0,false,'before')) {

				$cpt = 0;
				// $html .= '<h2>'.$this->__( 'Last articles', 'spxvisualwizard' ).'</h2>';


				/*$acol = explode("-", $colsnum);
				$ncol = $acol[1];
				// echo ("ncol=".$ncol);
				$w = 120 * $ncol;
				$h = 120 * $ncol;*/

				switch ($colsnum) {

					case "vwi_lrg-1":
						$colsnum.=" vwi_med-2";
						// passe resoltion 1/6 tablet;
						$w = 170;
						$h = 170;
					break;
					case "vwi_lrg-2":
						$colsnum.=" vwi_med-4";
						// passe resoltion 1/3 tablet;
						$w = 342;
						$h = 342;
					break;
					case "vwi_lrg-3":
						$colsnum.=" vwi_med-6";
						// passe resoltion 1/2 tablet;
						$w = 512;
						$h = 512;
					break;
					case "vwi_lrg-4":
						// passe resoltion tablet car 12;
						$w = 1024;
						$h = 1024;
					break;
					case "vwi_lrg-6":
						// passe resoltion tablet car 12;
						$w = 1024;
						$h = 1024;
					break;
					case "vwi_lrg-12":
						$w = 1024;
						$h = 1024;
					break;

				}



				switch ($imageratio) {

					case "square":
						$w=$w;
						$h=$h;
					break;
					case "4/3":
						$w=$w;
						$h=$h*3/4;
					break;
					case "3/4":
						$w=$w*3/4;
						$h=$h;
					break;
					case "16/9":
						$w=$w;
						$h=$h*9/16;
					break;
					default:
						$w=$w;
						$h=$h;
					break;
				}

				foreach($files as $filename) {

					$tmp = $plxMotor->parseArticle(PLX_ROOT.$plxMotor->aConf['racine_articles'].$filename);

					//plxUtils::debug($tmp); // important pour connaitre le détail
					$art = array(
						'id'		=> $tmp['numero'],
						'url' 		=> $plxMotor->urlRewrite('?article'.intval($tmp['numero']).'/'.$tmp['url']),
						'title' 	=> $tmp['title'],
						'date'		=> $tmp['date'],
						'author'	=> $plxMotor->aUsers[$tmp['author']]['name'],
						'nb_com' 	=> $tmp['nb_com'],
						'thumbnail'  => $tmp['thumbnail'],
						'thumbnail_title'  => $tmp['thumbnail_title'],
						'thumbnail_alt'  => $tmp['thumbnail_alt'],
						'chapo'		=> $tmp['chapo'],
						'categorie'	=> $tmp['categorie'],
						'tags'		=> $tmp['tags'],
					);
					//plxUtils::debug($art);

					# categories
					$cats = explode(",", $art['categorie']);
					//plxUtils::debug( $cats );
					if (in_array( $catid, $cats) || $catid=='') {
					    $showCat = true;
					} else{
						$showCat = false;
					}
					// bug a voir avec cfdev ?
					$showCat = true;

					# recupère le chapo sans les balises.
					$text = strip_tags ($art['chapo']);
					# Couper la chaine à 140 mots twitter power ;)
					$resume = wordwrap($text, 140, "***", false);
					# Creation d'un tableau
					$tcut = explode("***", $resume);
					# Récupération de la première ligne de 100 mots
					$resume = $tcut[0].' ...';

					# Mise en forme de la datetime
					$artDateTime = substr($art['date'],6,2).'/'.substr($art['date'],4,2).'/'.substr($art['date'],0,4);

					// Si categorie visible et le nombre voulu
					if( ($showCat == true) && ($cpt++ < $art_nb) ) {
						//
						// vwi_lrg-4
						$html .= '<article class="vwi_col '.$colsnum.' ">';

							$html .= '<header>';
								if ($bimage=='1') {
									$html .= '<a href="'.$art['url'].'" title="'.$art['title'].'">';

									if ($art['thumbnail'] != ""){
										$src = $widget_path.'assets/thumb.php?src='.$racine_path.$art['thumbnail'].'&w='.$w.'&h='.$h.'&s=1&q=92';

									} else{

										$src = $widget_path.'assets/thumb.php?src='.VIW_URL.'/widgets/widgets/plxlastart/img/news.png&w='.$w.'&h='.$h.'&s=1&q=92';

									}

									$html .= '<img src="'.$src.'" class="center img-responsive thumbnail" alt="'.$art['title'].'"/>';

									$html .='</a>';


								}

								if ($btitle=='1') {
									$html .= '<'.$titlelevel.'><a href="'.$art["url"].'" title="'.$art["title"].'">'.$art["title"].'</a></'.$titlelevel.'>';
								}



								if ($bdate=='1')
									$html .= '<div class="date">'.$artDateTime.'</div>';

							$html .= '</header>';

								$html .= '<p>'.$resume.'</p>';
								if ($breadmore=='1')
									$html .= '<footer><p class="more"><a href="'.$art["url"].'" title="">'.$this->__( 'Read more', 'spxvisualwizard' ).' <i class="fa fa-angle-right" aria-hidden="true"></i></a></p></footer>';
									//


						$html .= '</article>';
					}
				}
			}
			$html .= '<div class="viw_clearfix" ></div>';
			$html .= '</div>';
			return $html;
		}


		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$plxMotor = plxMotor::getInstance();
			# On verifie qu'il y a des categories
			$acategorie = array();

			$acategorie['']= $this->__( 'All categories', 'spxvisualwizard' );

			if($plxMotor->aCats) {
				foreach($plxMotor->aCats as $k=>$v) {
					if(($v['articles']>0 OR $plxMotor->aConf['display_empty_cat']) AND $v['active']) { # On a des articles
						$acategorie[$k]=$v['name'];
					}

				} # Fin du while
			}


			# toggle bg type
			$atoggle_display_title = array (
				'0' => array (),
				'1' => array (
					'field' => array (
						'titlelevel'
					),
				),



			);

			$ajsontoggle_display_title = htmlspecialchars(json_encode($atoggle_display_title), ENT_QUOTES, 'UTF-8');

			# toggle image ratio
			$atoggle_display_image = array (
				'0' => array (),
				'1' => array (
					'field' => array (
						'imageratio'
					),
				),



			);

			$ajsontoggle_display_image = htmlspecialchars(json_encode($atoggle_display_image), ENT_QUOTES, 'UTF-8');





			$options = array(


				array(
					'title' => $this->__( 'Structure', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),

				array(
					'param_name' => 'catid',
					'title' => $this->__( 'Categories', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $catid,
					'data' => $acategorie,
				),

				array(
					'param_name' => 'artsnum',
					'title' => $this->__( 'Number of articles', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'sliderMinMax',
					'min' => 1,
					'max' => 12,
					'value' => $artsnum,
				),

				array(
					'param_name' => 'colsnum',
					'title' => $this->__( 'Number of columns', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $colsnum,
					'data' => array(
						'vwi_lrg-12' =>  $this->__( '1', 'spxvisualwizard' ),
						'vwi_lrg-6' => $this->__( '2', 'spxvisualwizard' ),
						'vwi_lrg-4' => $this->__( '3', 'spxvisualwizard' ),
						'vwi_lrg-3' => $this->__( '4', 'spxvisualwizard' ),
						'vwi_lrg-2' => $this->__( '6', 'spxvisualwizard' ),
						'vwi_lrg-1' => $this->__( '12', 'spxvisualwizard' ),

					),
				),

				array(
					'title' => $this->__( 'Display', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),

				array(
					'param_name' => 'bimage',
					'title' => $this->__( 'Display image', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $bimage,
					'innerextra' => ' data-toggle="'.$ajsontoggle_display_image.'" ',
					'class' => 'viw_ui-needtoggle',
					'data' => array(
						'1' => $this->__( 'Show', 'spxvisualwizard' ),
						'0' => $this->__( 'Hide', 'spxvisualwizard' ),
					),
				),

				array(
					'param_name' => 'imageratio',
					'title' => $this->__( 'Ratio image', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $imageratio,


					'data' => array(
						'default' =>  $this->__( 'default', 'spxvisualwizard' ),
						'square' =>  $this->__( 'square', 'spxvisualwizard' ),
						'4/3' =>  $this->__( '4/3', 'spxvisualwizard' ),
						'3/4' =>  $this->__( '3/4', 'spxvisualwizard' ),
						'16/9' =>  $this->__( '16/9', 'spxvisualwizard' ),


					),
				),

				array(
					'param_name' => 'btitle',
					'title' => $this->__( 'Display title', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $btitle,
					'innerextra' => ' data-toggle="'.$ajsontoggle_display_title.'" ',
					'class' => 'viw_ui-needtoggle',
					'data' => array(
						'1' => $this->__( 'Show', 'spxvisualwizard' ),
						'0' => $this->__( 'Hide', 'spxvisualwizard' ),
					),
				),

				array(
					'param_name' => 'titlelevel',
					'title' => $this->__( 'Level of the title', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $titlelevel,
					'data' => array(
						'h1' =>  $this->__( 'h1', 'spxvisualwizard' ),
						'h2' =>  $this->__( 'h2', 'spxvisualwizard' ),
						'h3' =>  $this->__( 'h3', 'spxvisualwizard' ),
						'h4' =>  $this->__( 'h4', 'spxvisualwizard' ),
						'h5' =>  $this->__( 'h5', 'spxvisualwizard' ),
						'h6' =>  $this->__( 'h6', 'spxvisualwizard' )

					),
				),

				array(
					'param_name' => 'bdate',
					'title' => $this->__( 'Display date', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $bdate,
					'data' => array(
						'1' => $this->__( 'Show', 'spxvisualwizard' ),
						'0' => $this->__( 'Hide', 'spxvisualwizard' ),
					),
				),

				array(
					'param_name' => 'breadmore',
					'title' => $this->__( 'Display read more', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $breadmore,
					'data' => array(
						'1' => $this->__( 'Show', 'spxvisualwizard' ),
						'0' => $this->__( 'Hide', 'spxvisualwizard' ),
					),
				),


			);


			return $this->get_options($options);
		}

		public function template_wireframe_formatter() {
			?>
			<script type="text/javascript">
				var tmpplxlastartformatter = {
						"plxlastart_structure": function (artsnum, colsnum, bimage, btitle, titlelevel, bdate, breadmore ) {
							var s = '';

							for (var i=0 ; i<Number(artsnum); i++){
								s +='<article class="vwi_col '+colsnum+'">';
									s +='<header>';
										if (bimage=='1'){
											s +='<a href="" title="">';
												s +='<img src="'+VIWPROP.root_plugins+'widgets/widgets/plxlastart/img/news.jpg" class="" alt="">';
											s +='</a>';
										}


										if (btitle=='1')  s +='<'+titlelevel+'><a href="" title="My title">My title</a></'+titlelevel+'>';

										if (bdate=='1') s +='<div class="date">Date</div>';
									s +='</header>';

										s +='<p>Lorem ipsum dolor...</p>';

									if (breadmore=='1') s +='<footer><p class="more"><a href="" title="">Read more<i class="fa fa-angle-right" aria-hidden="true"></i></a></p></footer>';

								s +='</article>';
							}


							return s;

						}
				}

				Mustache.Formatters = Object.assign(Mustache.Formatters, tmpplxlastartformatter);
			</script>
			<?php
		}

		public function template_preview() {
			?>
			<script id="id_viw_template_widget_preview_plxlastart" type="x-tmpl-mustache">

				<div style="" class="viw_plxlasart  ">
					<h2>Last articles</h2>
					{{{ artsnum | plxlastart_structure : colsnum : bimage : btitle : titlelevel : bdate : breadmore}}}
				</div>

			</script>

			<?php
		}

		public function template_wireframe() {
			?>
				<script id="id_viw_template_widget_wireframe_plxlastart" type="x-tmpl-mustache">
				<div class="viw_ui-widget-title-container">
					<div class="viw_ui-widget-icon-container">
					<span class="viw_ui-widget-icon viw_ui-widget-icon-{{ type }}"></span></div>
				{{ type | uppercase }}
				</div>

				<?php
				?>

				</script>
			<?php
		}


	}

}
?>