<?php

if (class_exists('spxvisualwizardWidget')) {

	class plxsidebar extends spxvisualwizardWidget {

		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->name = 'plxsidebar';
			$this->title = $this->__( 'title-plxsidebar', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-plxsidebar', 'spxvisualwizard' );
			$this->category = "Pluxml";

			$options = array(

				'color' => '#000000',
				'level' => 'h3',

			);

			$this->default_options = $this->merge_advanced_default_options($options);

			$this->add_shortcode();
		}

		public function add_shortcode(){
			add_shortcode( 'viw_plxsidebar', array( $this, 'shortcode_frontend' ) );
		}

		public function shortcode_frontend( $atts, $content ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$class  = 'viw_plxsidebar';

			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$styleadv = $oaof["style"];
			$idadv = $oaof["id"];
			$class .= $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */

			$cssstyle = 'style="';
			if ($color !='') $cssstyle .= 'color: '.$color.' ;';
			$cssstyle .= $styleadv;
			$cssstyle .= '"';

			$mycontent = $this->get_content($level);

			$html = '<div '.$cssstyle.$idadv.' class="'.$class.'" '.$extra.' >'.$mycontent.'</div>';

			return $html;
		}

		public function get_content($level){

			$plxShow=plxShow::getInstance();

			ob_start();
			$plxShow->catList('','<li id="#cat_id"><a class="#cat_status" href="#cat_url" title="#cat_name"><i class="fa fa-angle-right" aria-hidden="true"></i> #cat_name</a> (#art_nb)</li>');
			$scatlist = ob_get_clean();

			ob_start();
			$plxShow->lastArtList('<li><a class="#art_status" href="#art_url" title="#art_title"><i class="fa fa-angle-right" aria-hidden="true"></i> #art_title</a></li>');
			$slastArtList = ob_get_clean();

			ob_start();
			$plxShow->tagList('<li class="tag #tag_size"><a class="#tag_status" href="#tag_url" title="#tag_name"><i class="fa fa-angle-right" aria-hidden="true"></i> #tag_name</a></li>');
			$stagList = ob_get_clean();

			ob_start();
			$plxShow->lastComList('<li><a href="#com_url"><i class="fa fa-angle-right" aria-hidden="true"></i> #com_author '.$plxShow->getLang('SAID').' : #com_content(34)</a></li>');
			$slastComList = ob_get_clean();

			ob_start();
			$plxShow->archList('<li id="#archives_id"><a class="#archives_status" href="#archives_url" title="#archives_name"><i class="fa fa-angle-right" aria-hidden="true"></i> #archives_name</a> (#archives_nbart)</li>');
			$sarchList = ob_get_clean();

			$plxShow->urlRewrite('feed.php?rss');
			$srss = ob_get_clean();

			ob_start();
			$plxShow->urlRewrite('feed.php?rss/commentaires');
			$srsscom =ob_get_clean();

			//$html = '<'.$level.'

			$s='
			<'.$level.' class="viw_plxsidebar-title" >
			'.$this->__( 'Categories', 'spxvisualwizard' ).'
			</'.$level.' >

			<ul class="viw_plxsidebar-ul">
				'.$scatlist.'
			</ul>

			<'.$level.' class="viw_plxsidebar-title" >
			'.$this->__( 'Latest articles', 'spxvisualwizard' ).'
			</'.$level.'>

			<ul class="viw_plxsidebar-ul">
				'.$slastArtList.'
			</ul>

			<'.$level.' class="viw_plxsidebar-title" >
			'.$this->__( 'Tags', 'spxvisualwizard' ).'
			</'.$level.'>

			<ul class="viw_plxsidebar-ul">
				'.$stagList.'
			</ul>

			<'.$level.' class="viw_plxsidebar-title" >
			'.$this->__( 'Latest comments', 'spxvisualwizard' ).'
			</'.$level.'>

			<ul class="viw_plxsidebar-ul">
				'.$slastComList.'
			</ul>


			<'.$level.' class="viw_plxsidebar-title" >
			'.$this->__( 'Archives', 'spxvisualwizard' ).'
			</'.$level.'>

			<ul class="viw_plxsidebar-ul">
				'.$sarchList.'
			</ul>

			<'.$level.' class="viw_plxsidebar-title" >
			RSS
			</'.$level.'>
			<ul class="viw_plxsidebar-ul viw_plxsidebar-ul-rss">
				<li><a href="'.$srss.'" title="'.$this->__( 'Rss feeds articles', 'spxvisualwizard' ).'"><i class="fa fa-rss" aria-hidden="true"></i> '.$this->__( 'Rss feeds articles', 'spxvisualwizard' ).'</a></li>
				<li><a href="'.$srsscom.'" title="'.$this->__( 'Rss feeds comments', 'spxvisualwizard' ).'"><i class="fa fa-rss" aria-hidden="true"></i> '.$this->__( 'Rss feeds comments', 'spxvisualwizard' ).'</a></li>
			</ul>

			';

			return $s;


		}



		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$options = array(

				array(
					'param_name' => 'color',
					'title' => $this->__( 'Color', 'spxvisualwizard' ),
					'desc' => $this->__( 'The color of the text.', 'spxvisualwizard' ),
					'type' => 'colordefault',
					'selected' => $color,
				),

				array(
					'param_name' => 'level',
					'title' => $this->__( 'Level', 'spxvisualwizard' ),
					'desc' => $this->__( 'The level of the title', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $level,
					'data' => array(
						'h1' =>  $this->__( 'h1', 'spxvisualwizard' ),
						'h2' =>  $this->__( 'h2', 'spxvisualwizard' ),
						'h3' =>  $this->__( 'h3', 'spxvisualwizard' ),
						'h4' =>  $this->__( 'h4', 'spxvisualwizard' ),
						'h5' =>  $this->__( 'h5', 'spxvisualwizard' ),
						'h6' =>  $this->__( 'h6', 'spxvisualwizard' )



					),
				),


			);


			return $this->get_options($options);
		}


		public function template_wireframe() {
			?>
				<script id="id_viw_template_widget_wireframe_plxsidebar" type="x-tmpl-mustache">
				<div class="viw_ui-widget-title-container">
					<div class="viw_ui-widget-icon-container">
						<span class="viw_ui-widget-icon viw_ui-widget-icon-{{ type }}"></span>
					</div>
					{{ type | uppercase }}
				</div>
				</script>
			<?php
		}

	}

}
?>