<?php

if (class_exists('spxvisualwizardWidget')) {

	class rawhtml extends spxvisualwizardWidget {

		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->name = 'rawhtml';
			$this->title = $this->__( 'title-rawhtml', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-rawhtml', 'spxvisualwizard' );
			$this->category = "Content";
			$this->dependencies = array(

			);

			$options = array(

				'content' => '',
				'color' => '#000000',
				'class' => ''

			);

			$this->default_options = $this->merge_advanced_default_options($options);

			$this->add_shortcode();
		}

		public function add_shortcode(){
			add_shortcode( 'viw_rawhtml', array( $this, 'shortcode_frontend' ) );
		}

		public function shortcode_frontend( $atts, $content ){
			//$mycontent = rawurldecode(base64_decode(strip_tags($content)));

			$mycontent = stripslashes(rawurldecode($content));
			$mycontent = str_replace("&#34;", '"', $mycontent);

			$mycontent = do_shortcode($mycontent);
			// return $(“<div/>”).text(rawurldecode(base64_decode(value))).html();
			// return $(“<div/>”).text(rawurldecode(value)).html();

			extract( shortcode_atts( $this->default_options, $atts ) );



			$class  = 'vwi_rawhtml';

			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$styleadv = $oaof["style"];
			$idadv = $oaof["id"];
			$class .= $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */


			$cssstyle = 'style="';
			if ($color!='')
				$cssstyle .= 'color: '.$color.' ;';
			$cssstyle .= $styleadv;
			$cssstyle .= '"';

			$html = '<div '.$cssstyle.$idadv.' class="'.$class.'" '.$extra.' >'.$mycontent.'</div>';

			return $html;
		}

		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$options = array(



				array(
					'param_name' => 'content',
					'title' => $this->__( 'Content', 'spxvisualwizard' ),
					'desc' => $this->__( '', 'spxvisualwizard' ),
					'type' => 'textarea',

					'rows' => '20',
					'value' => $content,
				),

				array(
					'param_name' => 'color',
					'title' => $this->__( 'Color', 'spxvisualwizard' ),
					'desc' => $this->__( 'The color of the text.', 'spxvisualwizard' ),
					'type' => 'colordefault',
					'selected' => $color,
				),


			);


			return $this->get_options($options);
		}

		public function template_preview() {
			// viwutils.str_replace("&#34;", '"', viwutils.stripslashes(viwutils.rawurldecode(" {{{ content }}} ")))
			?>
			<script id="id_viw_template_widget_preview_rawhtml" type="x-tmpl-mustache">
				<div style="color:{{ color }}; {{ adv_mc | adv_margin : adv_mun : adv_mt : adv_mb : adv_ml : adv_mr }}" class="vwi_rawhtml" >
				{{{ content2 }}}
				</div>

			</script>
			<?php
		}

		public function template_wireframe() {
			?>
				<script id="id_viw_template_widget_wireframe_rawhtml" type="x-tmpl-mustache">
				<div class="viw_ui-widget-title-container">
					<div class="viw_ui-widget-icon-container">
						<span class="viw_ui-widget-icon viw_ui-widget-icon-{{ type }}"></span>
					</div>
					{{ type | uppercase }}
				</div>
				</script>
			<?php
		}

	}

}
?>