<?php

if (class_exists('spxvisualwizardWidget')) {

	class row extends spxvisualwizardWidget {


		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->name = 'row';
			$this->title = $this->__( 'title-row', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-row', 'spxvisualwizard' );
			$this->category = "Structure";
			$this->dependencies = array(

			);

			$options = array(
				'bgcolor' => 'inherit',
				'bgcolor_dark' => 'inherit',
				'bgcolor_light' => 'inherit',

				'col_alignement' => 'default',
				'contentwidth' => 'fixed',
				'gutw' => '15'


			);

			$this->default_options = $this->merge_advanced_default_options($options);

			$this->add_shortcode();
		}

		public function add_shortcode(){
			add_shortcode( 'viw_row', array( $this, 'shortcode_frontend' ) );
		}

		public function shortcode_frontend( $atts, $content ){
			$content = do_shortcode($content);
			extract( shortcode_atts( $this->default_options, $atts ) );


			$class  = 'vwi_row';
			if ($col_alignement != 'default'){
				$class  .= ' vwi_flex vwi_flexRow vwi_flexWrap '.$col_alignement;
			}

			$cssstyle = 'style="';
			//$cssstyle .= 'background-color:'.$bgcolor.';';
			//$cssstyle .= 'width:100%;';
			/*$plxMotor =  plxMotor::getInstance();
			$spxvisualwizard = $plxMotor->plxPlugins->aPlugins["spxvisualwizard"];
			$w = $spxvisualwizard->getParam('viwcontainerwidth');*/

			if ($contentwidth == "fixed"){
				//$cssstyle .= 'max-width: 1280px;';
				$cssstyle .= 'max-width: '.VIW_CONTAINERWIDTH.'px;';
			}
			$cssstyle .= 'width: 100%;';

			// $cssstyle .= 'height:2000px;';


			//$html = '<div '.$cssstyle.' class="'.$class.'">'.$content.'</div>';
			$cssstyle2 = 'style="';
			if ($bgcolor != "") $cssstyle2 .= 'background-color:'.$bgcolor.';';
			if ($gutw != '15'){
				$cssstyle2 .= 'margin-left: -'.$gutw.'px;';
				$cssstyle2 .= 'margin-right: -'.$gutw.'px;';
			}
			$cssstyle2 .= '"';

			$html = '';

			if ($gutw != '15'){
				$uniqid = uniqid();
				$class  .= ' vwi_row-'.$uniqid;
				$scopecss = '<style type="text/css" scoped="scoped">';
				$scopecss .= '.vwi_row.vwi_row-'.$uniqid.' .vwi_col {padding-left:'.$gutw.'px;padding-right:'.$gutw.'px;}';
				$scopecss .= '</style>';
				$html .= $scopecss;
			}

			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$cssstyle .= $oaof["style"];
			$idadv = $oaof["id"];
			$classcter = $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */

			$cssstyle .= '"';

			$html .= '<div '.$idadv.' '.$cssstyle.' class="vwi_container '.$classcter.'" '.$extra.' ><div  '.$cssstyle2.' class="'.$class.'">'.$content.'</div></div>';

			return $html;
		}

		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$options = array(

				array(
					'param_name' => 'contentwidth',
					'title' => $this->__( 'Width', 'spxvisualwizard' ),
					'desc' => $this->__( 'The width of the row.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $contentwidth,
					'data' => array(
						'fixed' =>  $this->__( 'Fixed', 'spxvisualwizard' ),
						'fullwidth' =>  $this->__( 'Full width', 'spxvisualwizard' ),



					),
				),

				array(
					'param_name' => 'col_alignement',
					'title' => $this->__( 'Col alignement', 'spxvisualwizard' ),
					'desc' => $this->__( 'The alignement of the col in the row.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $col_alignement,
					'data' => array(


						'default' =>  $this->__( 'Default', 'spxvisualwizard' ),
						'vwi_flexAlignItemsStart' =>  $this->__( 'Top', 'spxvisualwizard' ),
						'vwi_flexAlignItemsEnd' => $this->__( 'Bottom', 'spxvisualwizard' ),
						'vwi_flexAlignItemsCenter' => $this->__( 'Vertical center', 'spxvisualwizard' ),
						'vwi_flexAlignItemsStretch' =>  $this->__( 'Stretch', 'spxvisualwizard' )



					),
				),


				array(
						'param_name' => 'bgcolor',
						'title' => $this->__( 'Background color', 'spxvisualwizard' ),
						'desc' => $this->__( 'The bg color of the row.', 'spxvisualwizard' ),
						'type' => 'colordefault',
						'selected' => $bgcolor,
					),

				array(
					'param_name' => 'gutw',
					'title' => $this->__( 'Gutter width in pixels', 'spxvisualwizard' ),
					'desc' => $this->__( 'Gutter width in pixels desc.', 'spxvisualwizard'),
					'type' => 'sliderMinMax',
					'min' => 0,
					'max' => 60,
					'value' => $gutw,
				),

			);


			return $this->get_options($options);
		}


	}

}
?>