<?php



if (class_exists('spxvisualwizardWidget')) {

	class section extends spxvisualwizardWidget {

		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->name = 'section';
			$this->title = $this->__( 'title-section', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-section', 'spxvisualwizard' );
			$this->category = "Structure";

			$options = array(
				'title' => '',

				'bg_type' => 'none',
				'bgcolor' => '#ffffff',
				'bgcolor_dark' => '#ffffff',
				'bgcolor_light' => '#ffffff',

				'bgimage' => '',
				'row_alignement' => 'default',
				'height' => 'default',
				'width' => 'fixed',

				'textalign' => 'inherit',


				'headingcolor' => '',
				'headingcolor_dark' => '',
				'headingcolor_light' => '',
				'textcolor' => '',
				'textcolor_dark' => '',
				'textcolor_light' => '',
				'linkcolor' => '',
				'linkcolor_dark' => '',
				'linkcolor_light' => '',
				'linkhovercolor' => '',
				'linkhovercolor_dark' => '',
				'linkhovercolor_light' => '',


				'ytid' => '',


				'particulecolor' => '#555555',
				'particulecolor_dark' => '#555555',
				'particulecolor_light' => '#555555',

				'geopattern' => '',

				'segstyle' => 'randall',
				'segnpiece' => 6,

				/*'id' => '',
				'cl' => '',*/

			);

			$this->default_options = $this->merge_advanced_default_options($options);

			$this->add_shortcode();
		}

		public function add_shortcode(){
			add_shortcode( 'viw_section', array( $this, 'shortcode_frontend' ) );
		}

		public function shortcode_frontend( $atts, $content ){
			$content = do_shortcode($content);
			extract( shortcode_atts( $this->default_options, $atts ) );

			$html ='';
			$uniqid = uniqid();
			$class  = 'vwi_section';
			if ($row_alignement != 'default'){
				$class  .= ' vwi_flex vwi_flexCol vwi_flexWrap vwi_flexAlignItemsStretch '.$row_alignement;
			}
			if ($height != 'default'){
				$class  .= ' vwi_section-'.$height;
			}

			$cssstyle = 'style="';

			$plxMotor =  plxMotor::getInstance();
			$basepath_image = isset($plxMotor->aConf['medias']) ? $plxMotor->aConf['medias'] : $plxMotor->aConf['images'];

			# instance plugin should be change
			/*$spxvisualwizard = $plxMotor->plxPlugins->aPlugins["spxvisualwizard"];
			$w = $spxvisualwizard->getParam('viwcontainerwidth');*/

			if ($bgimage !="") {
				// $cssstyle .= 'background-image: url(\''.PLX_ROOT.$basepath_image.$bgimage.'\') ;';
			}else{
				// $cssstyle .= 'background-color:'.$bgcolor.';';
			}
			if ($width == "fixed"){
				//$cssstyle .= 'max-width: 1280px;';
				$cssstyle .= 'max-width: '.VIW_CONTAINERWIDTH.'px;';
			}
			$cssstyle .= 'width: 100%;';
			$cssstyle .= 'text-align:'.$textalign.';';

			if ($textcolor !=''){
				$cssstyle .= 'color:'.$textcolor.';';

			}

			// $cssstyle .= 'height:2000px;';


			/*$content = $content.'<div style="position: fixed; z-index: -99; width: 100%; height: 100%">
			<iframe frameborder="0" height="100%" width="100%"
			src="https://youtube.com/embed/4aKhZjVj55g?autoplay=1&controls=0&showinfo=0&autohide=1">
			</iframe>
			</div>';*/




			switch ($bg_type) {
				case "none":

					break;
				case 'particule':
					if ($bgcolor!='')
						$cssstyle .= 'background-color:'.$bgcolor.';';
					/* https://codepen.io/natewiley/pen/Ciwyn/ */
					$classcontainer ="";
					if ($row_alignement != 'default'){
						$classcontainer  = ' vwi_flex vwi_flexCol vwi_flexWrap vwi_flexAlignItemsStretch '.$row_alignement;
					}

					$htmlparticule = '<div class="vwi_section-particule-item" style="width:100%;">';
						$htmlparticule .= '<div class="bubble-wrap">';
							$mycolor = new Color($particulecolor);
							$myhsl = $mycolor->getHsl();
							//print_r($myhsl);
							for ($i=0;$i<100;$i++){
								$myhsl1 = rand(0,360);

								$myhsl2 = ceil (intval ($myhsl["H"]));
								$inthsl1= $myhsl2-20;
								$inthsl2= $myhsl2+20;
								$myhsl2 = rand($inthsl1,$inthsl2);

								$size = rand(0,30)+"px";
								$styleparticule = 'height: '.$size.'px;
									width: 	'.$size.'px;
									animation-delay: '.(-$i * 0.2).'s;
									transform: translate3d('.rand(0,1000).'px, '.rand(0,1000).'px, '.rand(0,1000).'px);
									background: hsl( '.$myhsl2.' , 70%, 50%);';
								$htmlparticule .= '<div style="'.$styleparticule.'" class="viw-bubble"></div>';
							}

						$htmlparticule .= '</div>';
					$htmlparticule .= '</div>';



					$htmlcontainer = '<div class="vwi_section-container vwi_section-container-particule '.$classcontainer.'" >'.$content.'</div>';
					$content = $htmlcontainer.$htmlparticule;


					break;
				case 'color':
					if ($bgcolor!='')
						$cssstyle .= 'background-color:'.$bgcolor.';';
					break;
				case 'photo':
					$cssstyle .= 'background-image: url(\''.PLX_ROOT.$basepath_image.$bgimage.'\') ;';
					break;
				case 'video':

					$class  = 'vwi_section vwi_section-fullheight-video';
					$uniqidvideo = uniqid();
					$classcontainer ="";
					if ($row_alignement != 'default'){
						$classcontainer  = ' vwi_flex vwi_flexCol vwi_flexWrap vwi_flexAlignItemsStretch '.$row_alignement;
					}
					/*
					$htmlvideo = '<div class="vwi_section-video-item" style="width:100%;">
						<iframe id="'.$uniqidvideo.'" frameborder="0" allowfullscreen="" src="http://www.youtube.com/embed/bgxCKo5O_CA?autoplay=1&controls=1&loop=1&volume=0" ></iframe>
					</div>';
					*/
					$htmlvideo = '<div class="vwi_section-video-item" style="width:100%;">
						<div id="'.$uniqidvideo.'" ></div>
					</div>';
					$htmlcontainer = '<div class="vwi_section-container '.$classcontainer.'" >'.$content.'</div>';
					// https://github.com/nirvanatikku/jQuery-TubePlayer-Plugin
					$htmljsmute = '
					<script>
					$(document).ready(function(){
						// not working in demo mode
						if ($("#id_vwi_ui-modal-content-right").length == 0){
							$("#'.$uniqidvideo.'").tubeplayer({
								initialVideo: "'.$ytid.'", // the video that is loaded into the player
								width: 800,
								autoPlay: true,
								loop: 1,
								showControls: false,                 // whether the player should have the controls visible, 0 or 1
								showRelated: false,
								onPlayerPlaying: function() {
									this.tubeplayer("mute");
								}
							}
							);
						}


					})
					</script>


					';


					$content = $htmlcontainer.$htmlvideo.$htmljsmute;


					break;
				case 'parallax':
					/* http://pixelcog.github.io/parallax.js/ */
					$sparallax = ' data-parallax="scroll" data-image-src="'.PLX_ROOT.$basepath_image.$bgimage.'" ';
					$class .=' parallax-window';
					break;
				case 'geopattern':
					$geoclass = "vwi_section-geopattern-".uniqid();
					$class  .= ' '.$geoclass;
					// https://github.com/btmills/geopattern https://github.com/jasonlong/geo_pattern
					/*

					string Will be hashed using the SHA1 algorithm, and the resulting hash will be used as the seed for generation.

					options.color Specify an exact background color. This is a CSS hexadecimal color value.

					options.baseColor Controls the relative background color of the generated image. The color is not identical to that used in the pattern because the hue is rotated by the generator. This is a CSS hexadecimal color value, which defaults to #933c3c.

					options.generator Determines the pattern. All of the original patterns are available in this port, and their names are camelCased.

					*/
					if ($bgcolor=='') {
						$bgcolor = '#ffffff';
					}
					$html ="<script>
					$(document).ready(function(){
						$('.".$geoclass."').geopattern('".$geopattern."', {'color' : '".$bgcolor."'} );
					});
					</script>";
					break;
				case 'segmenter':
					// http://tympanus.net/codrops/2016/09/21/background-segment-effect-with-css-clip/

					$class  = 'vwi_section vwi_section-segmenter';
					if ($height != 'default'){
						$class  .= ' vwi_section-'.$height;
					}

					$uniqidseg = uniqid();
					$classcontainer ="";
					if ($row_alignement != 'default'){
						$classcontainer  = ' vwi_flex vwi_flexCol vwi_flexWrap vwi_flexAlignItemsStretch '.$row_alignement;

					}
					$htmlsegmenter = '<div id="segmenter-'.$uniqidseg.'" class="segmenter segmenter-'.$uniqidseg.'" style="width:100%;background-image: url(\''.PLX_ROOT.$basepath_image.$bgimage.'\') ;" >
					</div>';
					$htmlcontainer = '<div class="vwi_section-container-segmenter-content '.$classcontainer.'" >'.$content.'</div>';



					$content = $htmlcontainer.$htmlsegmenter;

					/* RANDOM STYLE */

					$pt1 = 0;
					$pt2 = 6;
					$pl1 = 0;
					$pl2 = 6;
					//$npieces = rand(4,11);
					$npieces = $segnpiece;

					switch ($segstyle) {
						case "randtop":
							$pt1 = 0;
							$pt2 = 2;
							$pl1 = 0;
							$pl2 = 9;
							break;
						case "randbot":
							$pt1 = 4;
							$pt2 = 8;
							$pl1 = 0;
							$pl2 = 9;
							break;
						case "randright":
							$pt1 = 0;
							$pt2 = 6;
							$pl1 = 5;
							$pl2 = 9;
							break;
						case "randleft":
							$pt1 = 0;
							$pt2 = 6;
							$pl1 = 0;
							$pl2 = 4;
							break;
						case "randcenter":
							$pt1 = 2;
							$pt2 = 3;
							$pl1 = 3;
							$pl2 = 4;
							break;
						case "grid2":
							$npieces = 4;
							break;

					}


					$spieces = "";
					for ($i=0;$i<$npieces;$i++){
						switch ($segstyle) {
							case "grid2":
								$squarew = 45;
								$squareh = 45;
								if ($i%2){
									$squaret = 0;
									if ($i==3) $squaret = 55;
									$squarel = $i*55;

								}else{
									$squaret = $i*55;
									$squarel = 0;

								}


							break;
							default:
								$squarew = rand(1,4)*10;
								$squareh = rand(1,4)*10;
								$squaret = rand($pt1,$pt2)*10;
								$squarel = rand($pl1,$pl2)*10;
							break;
						}

						if (($squaret + $squareh)>100) $squaret = 100- $squareh;
						if (($squarel + $squarew)>100) $squarel = 100- $squarew;
						$spieces.="{top: ".$squaret.", left: ".$squarel.", width: ".$squarew.", height: ".$squareh."},";
					}
					//$squarew = 50;

					$html ="<script>
					$(document).ready(function(){
						segmenter = new Segmenter(document.querySelector('.segmenter-".$uniqidseg."'), {
							pieces: ".$npieces.",
							animation: {
								duration: 2000,
								easing: 'easeInOutExpo',
								delay: 100,
								translateZ: 80
							},
							parallax: true,

							positions: [
								".$spieces."

							],

							//positions:'random',

							onReady: function() {
								var bcheck = false;
								if ($('.viw_ui-modal-preview-container').length>0){
									segmenter.animate();
								}else{
									/*
									$( window ).scroll(function() {
										console.log('window scroll segmenter');
										if (bcheck==false) {
											if (viwutils.visibleY(document.getElementById('segmenter-".$uniqidseg."'))){
												console.log('element in view');
												segmenter.animate();
												bcheck = true;
											}
										}
									});
									*/

									segmenter.animate();


								}




							}
						});
					});
					</script>";




					break;
			}



			//$sid='';
			// if ($id != '') $sid=' id="'.$id.'" ';
			// if ($cl != '') $class.=' '.$cl;

			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$cssstyle .= $oaof["style"];
			$idadv = $oaof["id"];
			$class .= $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */


			$cssstyle .= '"';

			# color
			$scopecss = '<style type="text/css" scoped="scoped">';
			# heading color
			if ($headingcolor != '') $scopecss .= '.vwi_section-'.$uniqid.' h1, .vwi_section-'.$uniqid.' h2, .vwi_section-'.$uniqid.' h3, .vwi_section-'.$uniqid.' h4, .vwi_section-'.$uniqid.' h5, .vwi_section-'.$uniqid.' h6 { color:'.$headingcolor.';}';
			# a color
			if ($linkcolor != '')  $scopecss .= '.vwi_section-'.$uniqid.' a { color:'.$linkcolor.';}';
			# a hove color
			if ($linkhovercolor != '')  $scopecss .= '.vwi_section-'.$uniqid.' a:hover { color:'.$linkhovercolor.';}';

			$scopecss .= '</style>';
			$class.=' vwi_section-'.$uniqid;
			$extra .= isset($sparallax)?$sparallax:'';
			$html .= $scopecss;
			$html .= '<div '.$idadv.' '.$cssstyle.' class="'.$class.'" '.$extra.'>'.$content.'</div>';

			return $html;
		}

		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			# toggle bg type
			$atoggle_bg_type = array (
				'none' => array (),
				'color' => array (
					'field' => array (
						'bgcolor'
					),
				),
				'photo' => array (
					'field' => array (
						'bgimage'
					),
				),
				'parallax' => array (
					'field' => array (
						'bgimage'
					),
				),
				'video' => array (
					'field' => array (
						'ytid'
					),
				),
				'particule' => array (
					'field' => array (
						'bgcolor',
						'particulecolor'
					),
				),
				'geopattern' => array (
					'field' => array (
						'bgcolor',
						'geopattern'
					),
				),
				'segmenter' => array (
					'field' => array (
						'bgimage',
						'segstyle',
						'segnpiece'
					),
				),


			);

			$ajsontoggle_bg_type = htmlspecialchars(json_encode($atoggle_bg_type), ENT_QUOTES, 'UTF-8');


			$options = array(

				array(
					'param_name' => 'title',
					'title' => $this->__( 'Title', 'spxvisualwizard' ),
					'desc' => $this->__( 'The title of the section', 'spxvisualwizard' ),
					'type' => 'text',
					'value' => $title,
				),

				array(
					'title' => $this->__( 'Structure', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),

				array(
					'param_name' => 'width',
					'title' => $this->__( 'Width', 'spxvisualwizard' ),
					'desc' => $this->__( 'The width of the section', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $width,
					'data' => array(
						'fixed' =>  $this->__( 'Fixed', 'spxvisualwizard' ),
						'fullwidth' =>  $this->__( 'Full width', 'spxvisualwizard' ),

					),
				),

				array(
					'param_name' => 'height',
					'title' => $this->__( 'Height', 'spxvisualwizard' ),
					'desc' => $this->__( 'The height of the section', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $height,
					'data' => array(
						'default' =>  $this->__( 'Default', 'spxvisualwizard' ),
						'fullheight' =>  $this->__( 'Full height', 'spxvisualwizard' ),
					),
				),

				array(
					'param_name' => 'row_alignement',
					'title' => $this->__( 'Row alignment', 'spxvisualwizard' ),
					'desc' => $this->__( 'The alignement rows in the section', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $row_alignement,
					'data' => array(
						'default' =>  $this->__( 'Default', 'spxvisualwizard' ),
						'vwi_flexJustifyStart' =>  $this->__( 'Top', 'spxvisualwizard' ),
						'vwi_flexJustifyEnd' => $this->__( 'Bottom', 'spxvisualwizard' ),
						'vwi_flexJustifyCenter' => $this->__( 'Vertical center', 'spxvisualwizard' ),
						'vwi_flexJustifyBetween' =>  $this->__( 'Vertical space between', 'spxvisualwizard' ),
						'vwi_flexJustifyAround' => $this->__( 'Vertical space around ', 'spxvisualwizard' ),


					),
				),

				array(
					'title' => $this->__( 'Color and text', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),

				array(
					'param_name' => 'textalign',
					'title' => $this->__( 'Text align', 'spxvisualwizard' ),
					'desc' => $this->__( 'The alignement of the text, button, icon...', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $textalign,
					'data' => array(
						'inherit' =>  $this->__( 'inherit', 'spxvisualwizard' ),
						'left' =>  $this->__( 'left', 'spxvisualwizard' ),
						'right' => $this->__( 'right', 'spxvisualwizard' ),
						'center' => $this->__( 'center', 'spxvisualwizard' ),
						'justify' =>  $this->__( 'justify', 'dnd-sustifyhortcodes' ),


					),
				),

				array(
						'param_name' => 'headingcolor',
						'title' => $this->__( 'Heading color', 'spxvisualwizard' ),
						'desc' => '',
						'type' => 'colordefault',
						'selected' => $headingcolor,
					),

				array(
						'param_name' => 'textcolor',
						'title' => $this->__( 'Text color', 'spxvisualwizard' ),
						'desc' => '',
						'type' => 'colordefault',
						'selected' => $textcolor,
					),

				array(
						'param_name' => 'linkcolor',
						'title' => $this->__( 'Link color', 'spxvisualwizard' ),
						'desc' => '',
						'type' => 'colordefault',
						'selected' => $linkcolor,
					),

				array(
						'param_name' => 'linkhovercolor',
						'title' => $this->__( 'Link hover color', 'spxvisualwizard' ),
						'desc' => '',
						'type' => 'colordefault',
						'selected' => $linkhovercolor,
					),

				array(
					'title' => $this->__( 'Background', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),

				array(
					'param_name' => 'bg_type',
					'title' => $this->__( 'Background type', 'spxvisualwizard' ),
					'desc' => $this->__( 'Background type description', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $bg_type,
					'innerextra' => ' data-toggle="'.$ajsontoggle_bg_type .'" ',
					'class' => 'viw_ui-needtoggle',
					'data' => array(
						'none' =>  $this->__( 'None', 'spxvisualwizard' ),
						'color' =>  $this->__( 'Color', 'spxvisualwizard' ),
						'photo' => $this->__( 'Photo', 'spxvisualwizard' ),
						'parallax' => $this->__( 'Parallax', 'spxvisualwizard' ),
						'video' => $this->__( 'Video', 'spxvisualwizard' ),
						'particule' => $this->__( 'Particule', 'spxvisualwizard' ),
						'geopattern' => $this->__( 'Geopattern', 'spxvisualwizard' ),
						// http://tympanus.net/codrops/2016/09/21/background-segment-effect-with-css-clip/
						'segmenter' => $this->__( 'Segmentation image', 'spxvisualwizard' ),
					),
				),

				array(
						'param_name' => 'bgcolor',
						'title' => $this->__( 'Background color', 'spxvisualwizard' ),
						'desc' => '',
						'type' => 'colordefault',
						'selected' => $bgcolor,
					),

				array(
						'param_name' => 'particulecolor',
						'title' => $this->__( 'Particule color', 'spxvisualwizard' ),
						'desc' => '',
						'type' => 'colordefault',
						'selected' => $particulecolor,
					),

				array(
						'param_name' => 'bgimage',
						'title' => $this->__( 'Background image', 'spxvisualwizard' ),
						'desc' => '',
						'type' => 'image',
						'value' => $bgimage,
					),

				array(
						'param_name' => 'ytid',
						'title' => $this->__( 'Youtube id', 'spxvisualwizard' ),
						'desc' => $this->__( 'The Youtube id.', 'spxvisualwizard' ),
						'type' => 'ytid',
						'value' => $ytid,
					),

				array(
					'param_name' => 'geopattern',
					'title' => $this->__( 'Geopattern', 'spxvisualwizard' ),
					'desc' => $this->__( 'Geopattern description.', 'spxvisualwizard' ),
					'type' => 'geopattern',
					'value' => $geopattern,
				),

				array(
					'param_name' => 'segstyle',
					'title' => $this->__( 'Segmentation image', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'select',
					'selected' => $segstyle,
					'data' => array(
						'randall' =>  $this->__( 'Random all surface', 'spxvisualwizard' ),
						'randtop' =>  $this->__( 'Random top', 'spxvisualwizard' ),
						'randbot' =>  $this->__( 'Random bottom', 'spxvisualwizard' ),
						'randright' => $this->__( 'Random right', 'spxvisualwizard' ),
						'randleft' => $this->__( 'Random left', 'spxvisualwizard' ),
						'randcenter' =>  $this->__( 'Random center', 'spxvisualwizard'),
						'grid2' =>  $this->__( 'Grid 2x2', 'spxvisualwizard'),
					),
				),

				array(
					'param_name' => 'segnpiece',
					'title' => $this->__( 'Number of pieces', 'spxvisualwizard' ),
					'desc' => '',
					'type' => 'sliderMinMax',
					'min' => 1,
					'max' => 20,
					'value' => $segnpiece,
				),

				/*
				array(
					'title' => $this->__( 'CSS selectors', 'spxvisualwizard' ),
					'type' => 'grouptitle',
				),

				array(
						'param_name' => 'id',
						'title' => $this->__( 'ID', 'spxvisualwizard' ),
						'desc' => $this->__( 'A unique id apply to this section.', 'spxvisualwizard' ),
						'type' => 'text',
						'value' => $id,
					),

				array(
						'param_name' => 'cl',
						'title' => $this->__( 'Class', 'spxvisualwizard' ),
						'desc' => '',
						'type' => 'text',
						'value' => $cl,
					),
				*/








			);


			return $this->get_options($options);
		}


	}

}
?>