<?php

if (class_exists('spxvisualwizardWidget')) {

	class spacer extends spxvisualwizardWidget {
		
		
		
		public $icon = '';
		public $name = '';
		public $widgetname = '';
		public $description = '';
		public $category = '';
		public $dependencies = array();	
		public $default_options = array();
		
		
		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			$this->icon = '<span class="fa fa-bars"></span>';
			$this->name = 'spacer';
			$this->title = $this->__( 'title-spacer', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-spacer', 'spxvisualwizard' );
			$this->category = "Content";
			$this->dependencies = array(
				
			);
			
			$options = array(
				
				'height' => '32px',
				'class' => ''
				
			);
			
			$this->default_options = $this->merge_advanced_default_options($options);
			
			$this->add_shortcode();
		}
		
		public function add_shortcode(){
			add_shortcode( 'viw_spacer', array( $this, 'shortcode_frontend' ) );
		}
		
		public function shortcode_frontend( $atts, $content ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$class  = 'vwi_spacer';
			
			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$styleadv = $oaof["style"];
			$idadv = $oaof["id"];
			$class .= $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */
			
			
			$html = '<div '.$idadv.' class="'.$class.'" style="height: '.$height.'; '.$styleadv.'" '.$extra.' ></div>';
			
			return $html;
		}
		
		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );
			
			$options = array(
			
			
			
				array(
					'param_name' => 'height',
					'title' => $this->__( 'Height', 'spxvisualwizard' ),
					'desc' => $this->__( 'The height of the spacer.', 'spxvisualwizard' ),
					'type' => 'text',
					'value' => $height,
				),		
			
				
			);
			
			
			return $this->get_options($options);
		}
		
		public function template_preview() {
			?>
				<script id="id_viw_template_widget_preview_spacer" type="x-tmpl-mustache">
					<div class="vwi_spacer" style="height: {{ height }}; {{ adv_mc | adv_margin : adv_mun : adv_mt : adv_mb : adv_ml : adv_mr }}" ><i class="fa fa-arrows-v" aria-hidden="true"></i> {{ height }}</div>
				</script>
			<?php
		}
		
		public function template_wireframe() {
			?>
				<script id="id_viw_template_widget_wireframe_spacer" type="x-tmpl-mustache">
				<div class="viw_ui-widget-title-container">
					<div class="viw_ui-widget-icon-container">
					<span class="viw_ui-widget-icon viw_ui-widget-icon-{{ type }}"></span></div>
				{{ type | uppercase }}
				</div>
				<div class="viw_ui-widget-label viw_truncate" >{{ height }}</div>
				</script>
			<?php
		}
		
		
	}

}
?>