<?php

/*

un echo graf sur la première lettre
http://themes.hody.co/html/bezel/

<h2 data-bigletter="W">What We Do</h2>
.title h2[data-bigletter]:before {
    z-index: -1;
    content: attr(data-bigletter);
    font-size: 2em;
    opacity: .06;
    position: absolute;
    top: -0.5em;
    left: -0.15em;
    text-align: center;
    text-transform: uppercase;
}

*/

if (class_exists('spxvisualwizardWidget')) {

	class title extends spxvisualwizardWidget {


		/**
		 * Constructeur de la classe
		 *
		 * @param	default_lang	langue par défaut utilisée par PluXml
		 * @return	null
		 * @authors	je-evrard
		 **/
		public function __construct($default_lang) {
			# Appel du constructeur de la classe visualwizardWidget (obligatoire)
			parent::__construct($default_lang);
			$this->name = 'title';
			$this->title = $this->__( 'title-title', 'spxvisualwizard' );
			$this->description = $this->__( 'desc-title', 'spxvisualwizard' );
			$this->category = "Content";
			$this->dependencies = array(

			);

			$options = array(

				'content' => 'My title',
				'color' => '',
				'color_dark' => '',
				'color_light' => '',
				'textalign' => 'inherit',
				'level' => 'h3',
				'size' => '',
			);

			$this->default_options = $this->merge_advanced_default_options($options);

			$this->add_shortcode();
		}

		public function add_shortcode(){
			add_shortcode( 'viw_title', array( $this, 'shortcode_frontend' ) );
		}

		public function shortcode_frontend( $atts, $content ){
			$mycontent = stripslashes(rawurldecode($content));
			extract( shortcode_atts( $this->default_options, $atts ) );

			$class  = 'vwi_title';

			/* add advanced option */
			$oaof = $this->get_o_advanced_options_front( $atts );
			$styleadv = $oaof["style"];
			$idadv = $oaof["id"];
			$class .= $oaof["class"];
			$extra = $oaof["extra"];
			/* end add advanced option */

			$cssstyle = 'style="';
			if ($color !='') $cssstyle .= 'color:'.$color.';';
			$cssstyle .= 'text-align:'.$textalign.';';
			$cssstyle .= $styleadv;

			$cssstyle .= '"';

			$html = '<'.$level.' '.$cssstyle.' class="'.$class.$idadv.'" '.$extra.' ><span class="vwi_title-text" >'.$mycontent.'</span></'.$level.'>';

			return $html;
		}

		public function shortcode_options( $atts ){
			extract( shortcode_atts( $this->default_options, $atts ) );

			$options = array(

				array(
					'param_name' => 'content',
					'title' => $this->__( 'Title', 'spxvisualwizard' ),
					'desc' => $this->__( '', 'spxvisualwizard' ),
					'type' => 'textarea',
					'value' => $content,
				),

				array(
					'param_name' => 'level',
					'title' => $this->__( 'Level', 'spxvisualwizard' ),
					'desc' => $this->__( 'The level of the text', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $level,
					'data' => array(
						'h1' =>  $this->__( 'h1', 'spxvisualwizard' ),
						'h2' =>  $this->__( 'h2', 'spxvisualwizard' ),
						'h3' =>  $this->__( 'h3', 'spxvisualwizard' ),
						'h4' =>  $this->__( 'h4', 'spxvisualwizard' ),
						'h5' =>  $this->__( 'h5', 'spxvisualwizard' ),
						'h6' =>  $this->__( 'h6', 'spxvisualwizard' )



					),
				),

				array(
					'param_name' => 'size',
					'title' => $this->__( 'Size', 'spxvisualwizard' ),
					'desc' => $this->__( 'The size of the text.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $size,
					'data' => array(
						'' => $this->__( 'inherit', 'spxvisualwizard' ),
						'1' => $this->__( '1', 'spxvisualwizard' ),
						'2' => $this->__( '2', 'spxvisualwizard' ),
						'3' => $this->__( '3', 'spxvisualwizard' ),
						'4' => $this->__( '4', 'spxvisualwizard' ),
						'5' => $this->__( '5', 'spxvisualwizard' ),
						'6' => $this->__( '6', 'spxvisualwizard' )
					),
				),

				array(
					'param_name' => 'textalign',
					'title' => $this->__( 'Text align', 'spxvisualwizard' ),
					'desc' => $this->__( 'The alignement of the text.', 'spxvisualwizard' ),
					'type' => 'select',
					'selected' => $textalign,
					'data' => array(
						'inherit' =>  $this->__( 'inherit', 'spxvisualwizard' ),
						'left' =>  $this->__( 'left', 'spxvisualwizard' ),
						'right' => $this->__( 'right', 'spxvisualwizard' ),
						'center' => $this->__( 'center', 'spxvisualwizard' ),
						'justify' =>  $this->__( 'justify', 'spxvisualwizard' ),


					),
				),

				array(
						'param_name' => 'color',
						'title' => $this->__( 'Color', 'spxvisualwizard' ),
						'desc' => $this->__( 'The color of the text.', 'spxvisualwizard' ),
						'type' => 'colordefault',
						'selected' => $color,
					),


			);


			return $this->get_options($options);
		}

		public function template_preview() {
			?>
			<script id="id_viw_template_widget_preview_title" type="x-tmpl-mustache">
				<{{ level }} style="text-align:{{ textalign }}; color:{{ color }}; {{ adv_mc | adv_margin : adv_mun : adv_mt : adv_mb : adv_ml : adv_mr }}" class="vwi_title"><span class="vwi_title-text" >{{{ content2 }}}</span></{{ level }}></a>
			</script>
			<?php
		}

		public function template_wireframe() {
			?>
				<script id="id_viw_template_widget_wireframe_title" type="x-tmpl-mustache">
				<div class="viw_ui-widget-title-container">
					<div class="viw_ui-widget-icon-container">
					<span class="viw_ui-widget-icon viw_ui-widget-icon-{{ type }}"></span></div>
				{{ type | uppercase }}
				</div>

				<div class="viw_ui-widget-label viw_truncate" >{{ content }}</div>
				</script>
			<?php
		}


	}

}
?>